/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 28 "conf_parser.y" /* yacc.c:339  */


#define YY_NO_UNPUT
#include <sys/types.h>
#include <string.h>

#include "config.h"
#include "stdinc.h"
#include "ircd.h"
#include "list.h"
#include "conf.h"
#include "conf_class.h"
#include "event.h"
#include "log.h"
#include "client.h"	/* for UMODE_ALL only */
#include "irc_string.h"
#include "memory.h"
#include "modules.h"
#include "s_serv.h"
#include "hostmask.h"
#include "send.h"
#include "listener.h"
#include "resv.h"
#include "numeric.h"
#include "s_user.h"
#include "motd.h"
#include "hook.h"
#include "ssl.h"

#include <openssl/rsa.h>
#include <openssl/bio.h>
#include <openssl/pem.h>
#include <openssl/dh.h>

#include "rsa.h"

int yylex(void);

static struct
{
  struct {
    dlink_list list;
  } mask,
    leaf,
    hub;

  struct {
    char buf[IRCD_BUFSIZE];
  } name,
    user,
    host,
    addr,
    bind,
    file,
    cert,
    ca,
    profile,
    rpass,
    spass,
    class,
    reason;

  struct {
    unsigned int value;
  } flags,
    modes,
    snomask_local,
    snomask_remote,
    size,
    type,
    port,
    aftype,
    ping_freq,
    max_perip,
    con_freq,
    min_idle,
    max_idle,
    max_total,
    max_global,
    max_local,
    soft_sendq,
    flood_burst,
    flood_limit,
    max_sendq,
    max_recvq,
    cidr_bitlen_ipv4,
    cidr_bitlen_ipv6,
    number_per_cidr,
    max_channels;

  struct
  {
    struct alias_entry *alias;
    struct sslprofile *ssl;
    struct sslprofile_identity *identity;
    struct dnsbl_entry *dnsbl;
    struct cloak_config *cloak;
  } ptr;
} block_state;

static void
reset_block_state(void)
{
  dlink_node *ptr = NULL, *ptr_next = NULL;

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.mask.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.mask.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.leaf.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.leaf.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.hub.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.hub.list);
    free_dlink_node(ptr);
  }

  memset(&block_state, 0, sizeof(block_state));
}


#line 197 "conf_parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_CONF_PARSER_H_INCLUDED
# define YY_YY_CONF_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACCEPT_PASSWORD = 258,
    ACCOUNT_WHOIS = 259,
    ADMIN = 260,
    AFTYPE = 261,
    ANTI_NICK_FLOOD = 262,
    ANTI_SPAM_EXIT_MESSAGE_TIME = 263,
    AUTOCONN = 264,
    BYTES = 265,
    KBYTES = 266,
    MBYTES = 267,
    CA_FILE = 268,
    CALLER_ID_WAIT = 269,
    CAN_FLOOD = 270,
    CHANNEL = 271,
    CIDR_BITLEN_IPV4 = 272,
    CIDR_BITLEN_IPV6 = 273,
    CIPHER_LIST = 274,
    CLASS = 275,
    CLOAK = 276,
    CLOAK_KEY = 277,
    CLOAK_KEY1 = 278,
    CLOAK_KEY2 = 279,
    CLOAK_KEY3 = 280,
    CONNECT = 281,
    CONNECTFREQ = 282,
    CYCLE_ON_HOST_CHANGE = 283,
    DEFAULT = 284,
    DEFAULT_FLOODCOUNT = 285,
    DEFAULT_FLOODTIME = 286,
    DEFAULT_SPLIT_SERVER_COUNT = 287,
    DEFAULT_SPLIT_USER_COUNT = 288,
    DEFER = 289,
    DENY = 290,
    DESCRIPTION = 291,
    DIE = 292,
    DISABLE_AUTH = 293,
    DISABLE_CHMODES = 294,
    DISABLE_FAKE_CHANNELS = 295,
    DISABLE_REMOTE_COMMANDS = 296,
    DNSBL = 297,
    DNSBL_EXEMPT = 298,
    DOTS_IN_IDENT = 299,
    DURATION = 300,
    EMAIL = 301,
    ENABLE_EXTBANS = 302,
    ENABLE_FORWARDING = 303,
    ENCRYPTED = 304,
    EXCEED_LIMIT = 305,
    EXEMPT = 306,
    FAILED_OPER_NOTICE = 307,
    FLATTEN_LINKS = 308,
    FLOOD_BURST = 309,
    FLOOD_LIMIT = 310,
    GECOS = 311,
    GENERAL = 312,
    GLINE = 313,
    GLINE_DURATION = 314,
    GLINE_ENABLE = 315,
    GLINE_EXEMPT = 316,
    GLINE_MIN_CIDR = 317,
    GLINE_MIN_CIDR6 = 318,
    GLINE_REQUEST_DURATION = 319,
    HAVENT_READ_CONF = 320,
    HIDDEN = 321,
    HIDDEN_NAME = 322,
    HIDE_IDLE_FROM_OPERS = 323,
    HIDE_SERVER_IPS = 324,
    HIDE_SERVERS = 325,
    HIDE_SERVICES = 326,
    HIDE_SPOOF_IPS = 327,
    HOST = 328,
    HTTP = 329,
    HUB = 330,
    HUB_MASK = 331,
    IDENTITY = 332,
    IGNORE_BOGUS_TS = 333,
    INVISIBLE_ON_CONNECT = 334,
    INVITE_THROTTLE = 335,
    IP = 336,
    IRCD_AUTH = 337,
    IRCD_FLAGS = 338,
    IRCD_SID = 339,
    JOIN_FLOOD_COUNT = 340,
    JOIN_FLOOD_TIME = 341,
    KILL = 342,
    KILL_CHASE_TIME_LIMIT = 343,
    KLINE = 344,
    KLINE_EXEMPT = 345,
    KLINE_REASON = 346,
    KNOCK_DELAY = 347,
    KNOCK_DELAY_CHANNEL = 348,
    LEAF_MASK = 349,
    T_LINK = 350,
    LINKS_DELAY = 351,
    LISTEN = 352,
    MASK = 353,
    MATCH = 354,
    MAX_ACCEPT = 355,
    MAX_BANS = 356,
    MAX_CHANNELS = 357,
    MAX_CHANS_PER_USER = 358,
    MAX_GLOBAL = 359,
    MAX_IDLE = 360,
    MAX_LOCAL = 361,
    MAX_NICK_CHANGES = 362,
    MAX_NICK_LENGTH = 363,
    MAX_NICK_TIME = 364,
    MAX_NUMBER = 365,
    MAX_TARGETS = 366,
    MAX_TOPIC_LENGTH = 367,
    MAX_WATCH = 368,
    MIN_IDLE = 369,
    MIN_NONWILDCARD = 370,
    MIN_NONWILDCARD_SIMPLE = 371,
    MODULE = 372,
    MODULES = 373,
    MOTD = 374,
    NAME = 375,
    NEED_ACCOUNT = 376,
    NEED_IDENT = 377,
    NEED_PASSWORD = 378,
    NETWORK_DESC = 379,
    NETWORK_NAME = 380,
    NICK = 381,
    NICK_COLLIDE_REALHOST = 382,
    NO_CREATE_ON_SPLIT = 383,
    NO_JOIN_ON_SPLIT = 384,
    NO_OPER_FLOOD = 385,
    NO_TILDE = 386,
    NUMBER = 387,
    NUMBER_PER_CIDR = 388,
    NUMBER_PER_IP = 389,
    OPER_ONLY = 390,
    OPER_ONLY_UMODES = 391,
    OPER_PASS_RESV = 392,
    OPER_SNOMASKS = 393,
    OPER_UMODES = 394,
    OPERATOR = 395,
    OPERS_BYPASS_CALLERID = 396,
    PACE_WAIT = 397,
    PACE_WAIT_SIMPLE = 398,
    PASSWORD = 399,
    PATH = 400,
    PING_COOKIE = 401,
    PING_TIME = 402,
    PORT = 403,
    QSTRING = 404,
    QUIET_ON_BAN = 405,
    RANDOM_IDLE = 406,
    REASON = 407,
    REDIRPORT = 408,
    REDIRSERV = 409,
    REHASH = 410,
    REMOTE = 411,
    REMOTEBAN = 412,
    RESV = 413,
    RESV_EXEMPT = 414,
    RSA_PRIVATE_KEY_FILE = 415,
    RSA_PUBLIC_KEY_FILE = 416,
    SCRIPT = 417,
    SECONDS = 418,
    MINUTES = 419,
    HOURS = 420,
    DAYS = 421,
    WEEKS = 422,
    MONTHS = 423,
    YEARS = 424,
    SEND_PASSWORD = 425,
    SENDQ = 426,
    SERVERHIDE = 427,
    SERVERINFO = 428,
    SERVER_NAME = 429,
    SESSION = 430,
    SHORT_MOTD = 431,
    T_SNOMASKS = 432,
    SOFT_SENDQ = 433,
    SPOOF = 434,
    SPOOF_NOTICE = 435,
    SQUIT = 436,
    SSL_CERTIFICATE_FILE = 437,
    SSL_CERTIFICATE_FINGERPRINT = 438,
    SSL_CONNECTION_REQUIRED = 439,
    SSL_DH_ELLIPTIC_CURVE = 440,
    SSL_DH_PARAM_FILE = 441,
    SSL_MESSAGE_DIGEST_ALGORITHM = 442,
    SSLPROFILE = 443,
    SSL_PROFILE = 444,
    STATS_E_DISABLED = 445,
    STATS_I_OPER_ONLY = 446,
    STATS_K_OPER_ONLY = 447,
    STATS_M_OPER_ONLY = 448,
    STATS_O_OPER_ONLY = 449,
    STATS_P_OPER_ONLY = 450,
    STATS_U_OPER_ONLY = 451,
    T_ALIAS = 452,
    T_ALL = 453,
    T_BOTS = 454,
    T_CALLERID = 455,
    T_CCONN = 456,
    T_CLUSTER = 457,
    T_DEAF = 458,
    T_DEBUG = 459,
    T_DLINE = 460,
    T_FARCONNECT = 461,
    T_FILE = 462,
    T_FULL = 463,
    T_HIDECHANNELS = 464,
    T_GLOBOPS = 465,
    T_INVISIBLE = 466,
    T_IPV4 = 467,
    T_IPV6 = 468,
    T_LOCOPS = 469,
    T_LOG = 470,
    T_MAX_CLIENTS = 471,
    T_NCHANGE = 472,
    T_NOCTCP = 473,
    T_NONONREG = 474,
    T_OPERWALL = 475,
    T_RECVQ = 476,
    T_REJ = 477,
    T_RESTART = 478,
    T_SASL_NAME = 479,
    T_SERVER = 480,
    T_SERVICE = 481,
    T_SERVICES_NAME = 482,
    T_SERVNOTICE = 483,
    T_SET = 484,
    T_SHARED = 485,
    T_SIZE = 486,
    T_SKILL = 487,
    T_SOFTCALLERID = 488,
    T_SPY = 489,
    T_SSL = 490,
    T_UMODES = 491,
    T_UNAUTH = 492,
    T_UNDLINE = 493,
    T_UNLIMITED = 494,
    T_UNRESV = 495,
    T_UNXLINE = 496,
    T_WALLOP = 497,
    T_WALLOPS = 498,
    T_WALLUSERS = 499,
    T_WEBIRC = 500,
    TBOOL = 501,
    THROTTLE_NUM = 502,
    THROTTLE_TIME = 503,
    TKLINE_EXPIRE_NOTICES = 504,
    TMASKED = 505,
    MASS_HIGHLIGHT_NICKS = 506,
    TS_MAX_DELTA = 507,
    TS_WARN_DELTA = 508,
    TWODOTS = 509,
    TYPE = 510,
    UNKLINE = 511,
    USE_LOGGING = 512,
    USE_TARGET_CHANGE = 513,
    USER = 514,
    VHOST = 515,
    VHOST6 = 516,
    WARN_NO_NLINE = 517,
    WLINE = 518,
    XLINE = 519
  };
#endif
/* Tokens.  */
#define ACCEPT_PASSWORD 258
#define ACCOUNT_WHOIS 259
#define ADMIN 260
#define AFTYPE 261
#define ANTI_NICK_FLOOD 262
#define ANTI_SPAM_EXIT_MESSAGE_TIME 263
#define AUTOCONN 264
#define BYTES 265
#define KBYTES 266
#define MBYTES 267
#define CA_FILE 268
#define CALLER_ID_WAIT 269
#define CAN_FLOOD 270
#define CHANNEL 271
#define CIDR_BITLEN_IPV4 272
#define CIDR_BITLEN_IPV6 273
#define CIPHER_LIST 274
#define CLASS 275
#define CLOAK 276
#define CLOAK_KEY 277
#define CLOAK_KEY1 278
#define CLOAK_KEY2 279
#define CLOAK_KEY3 280
#define CONNECT 281
#define CONNECTFREQ 282
#define CYCLE_ON_HOST_CHANGE 283
#define DEFAULT 284
#define DEFAULT_FLOODCOUNT 285
#define DEFAULT_FLOODTIME 286
#define DEFAULT_SPLIT_SERVER_COUNT 287
#define DEFAULT_SPLIT_USER_COUNT 288
#define DEFER 289
#define DENY 290
#define DESCRIPTION 291
#define DIE 292
#define DISABLE_AUTH 293
#define DISABLE_CHMODES 294
#define DISABLE_FAKE_CHANNELS 295
#define DISABLE_REMOTE_COMMANDS 296
#define DNSBL 297
#define DNSBL_EXEMPT 298
#define DOTS_IN_IDENT 299
#define DURATION 300
#define EMAIL 301
#define ENABLE_EXTBANS 302
#define ENABLE_FORWARDING 303
#define ENCRYPTED 304
#define EXCEED_LIMIT 305
#define EXEMPT 306
#define FAILED_OPER_NOTICE 307
#define FLATTEN_LINKS 308
#define FLOOD_BURST 309
#define FLOOD_LIMIT 310
#define GECOS 311
#define GENERAL 312
#define GLINE 313
#define GLINE_DURATION 314
#define GLINE_ENABLE 315
#define GLINE_EXEMPT 316
#define GLINE_MIN_CIDR 317
#define GLINE_MIN_CIDR6 318
#define GLINE_REQUEST_DURATION 319
#define HAVENT_READ_CONF 320
#define HIDDEN 321
#define HIDDEN_NAME 322
#define HIDE_IDLE_FROM_OPERS 323
#define HIDE_SERVER_IPS 324
#define HIDE_SERVERS 325
#define HIDE_SERVICES 326
#define HIDE_SPOOF_IPS 327
#define HOST 328
#define HTTP 329
#define HUB 330
#define HUB_MASK 331
#define IDENTITY 332
#define IGNORE_BOGUS_TS 333
#define INVISIBLE_ON_CONNECT 334
#define INVITE_THROTTLE 335
#define IP 336
#define IRCD_AUTH 337
#define IRCD_FLAGS 338
#define IRCD_SID 339
#define JOIN_FLOOD_COUNT 340
#define JOIN_FLOOD_TIME 341
#define KILL 342
#define KILL_CHASE_TIME_LIMIT 343
#define KLINE 344
#define KLINE_EXEMPT 345
#define KLINE_REASON 346
#define KNOCK_DELAY 347
#define KNOCK_DELAY_CHANNEL 348
#define LEAF_MASK 349
#define T_LINK 350
#define LINKS_DELAY 351
#define LISTEN 352
#define MASK 353
#define MATCH 354
#define MAX_ACCEPT 355
#define MAX_BANS 356
#define MAX_CHANNELS 357
#define MAX_CHANS_PER_USER 358
#define MAX_GLOBAL 359
#define MAX_IDLE 360
#define MAX_LOCAL 361
#define MAX_NICK_CHANGES 362
#define MAX_NICK_LENGTH 363
#define MAX_NICK_TIME 364
#define MAX_NUMBER 365
#define MAX_TARGETS 366
#define MAX_TOPIC_LENGTH 367
#define MAX_WATCH 368
#define MIN_IDLE 369
#define MIN_NONWILDCARD 370
#define MIN_NONWILDCARD_SIMPLE 371
#define MODULE 372
#define MODULES 373
#define MOTD 374
#define NAME 375
#define NEED_ACCOUNT 376
#define NEED_IDENT 377
#define NEED_PASSWORD 378
#define NETWORK_DESC 379
#define NETWORK_NAME 380
#define NICK 381
#define NICK_COLLIDE_REALHOST 382
#define NO_CREATE_ON_SPLIT 383
#define NO_JOIN_ON_SPLIT 384
#define NO_OPER_FLOOD 385
#define NO_TILDE 386
#define NUMBER 387
#define NUMBER_PER_CIDR 388
#define NUMBER_PER_IP 389
#define OPER_ONLY 390
#define OPER_ONLY_UMODES 391
#define OPER_PASS_RESV 392
#define OPER_SNOMASKS 393
#define OPER_UMODES 394
#define OPERATOR 395
#define OPERS_BYPASS_CALLERID 396
#define PACE_WAIT 397
#define PACE_WAIT_SIMPLE 398
#define PASSWORD 399
#define PATH 400
#define PING_COOKIE 401
#define PING_TIME 402
#define PORT 403
#define QSTRING 404
#define QUIET_ON_BAN 405
#define RANDOM_IDLE 406
#define REASON 407
#define REDIRPORT 408
#define REDIRSERV 409
#define REHASH 410
#define REMOTE 411
#define REMOTEBAN 412
#define RESV 413
#define RESV_EXEMPT 414
#define RSA_PRIVATE_KEY_FILE 415
#define RSA_PUBLIC_KEY_FILE 416
#define SCRIPT 417
#define SECONDS 418
#define MINUTES 419
#define HOURS 420
#define DAYS 421
#define WEEKS 422
#define MONTHS 423
#define YEARS 424
#define SEND_PASSWORD 425
#define SENDQ 426
#define SERVERHIDE 427
#define SERVERINFO 428
#define SERVER_NAME 429
#define SESSION 430
#define SHORT_MOTD 431
#define T_SNOMASKS 432
#define SOFT_SENDQ 433
#define SPOOF 434
#define SPOOF_NOTICE 435
#define SQUIT 436
#define SSL_CERTIFICATE_FILE 437
#define SSL_CERTIFICATE_FINGERPRINT 438
#define SSL_CONNECTION_REQUIRED 439
#define SSL_DH_ELLIPTIC_CURVE 440
#define SSL_DH_PARAM_FILE 441
#define SSL_MESSAGE_DIGEST_ALGORITHM 442
#define SSLPROFILE 443
#define SSL_PROFILE 444
#define STATS_E_DISABLED 445
#define STATS_I_OPER_ONLY 446
#define STATS_K_OPER_ONLY 447
#define STATS_M_OPER_ONLY 448
#define STATS_O_OPER_ONLY 449
#define STATS_P_OPER_ONLY 450
#define STATS_U_OPER_ONLY 451
#define T_ALIAS 452
#define T_ALL 453
#define T_BOTS 454
#define T_CALLERID 455
#define T_CCONN 456
#define T_CLUSTER 457
#define T_DEAF 458
#define T_DEBUG 459
#define T_DLINE 460
#define T_FARCONNECT 461
#define T_FILE 462
#define T_FULL 463
#define T_HIDECHANNELS 464
#define T_GLOBOPS 465
#define T_INVISIBLE 466
#define T_IPV4 467
#define T_IPV6 468
#define T_LOCOPS 469
#define T_LOG 470
#define T_MAX_CLIENTS 471
#define T_NCHANGE 472
#define T_NOCTCP 473
#define T_NONONREG 474
#define T_OPERWALL 475
#define T_RECVQ 476
#define T_REJ 477
#define T_RESTART 478
#define T_SASL_NAME 479
#define T_SERVER 480
#define T_SERVICE 481
#define T_SERVICES_NAME 482
#define T_SERVNOTICE 483
#define T_SET 484
#define T_SHARED 485
#define T_SIZE 486
#define T_SKILL 487
#define T_SOFTCALLERID 488
#define T_SPY 489
#define T_SSL 490
#define T_UMODES 491
#define T_UNAUTH 492
#define T_UNDLINE 493
#define T_UNLIMITED 494
#define T_UNRESV 495
#define T_UNXLINE 496
#define T_WALLOP 497
#define T_WALLOPS 498
#define T_WALLUSERS 499
#define T_WEBIRC 500
#define TBOOL 501
#define THROTTLE_NUM 502
#define THROTTLE_TIME 503
#define TKLINE_EXPIRE_NOTICES 504
#define TMASKED 505
#define MASS_HIGHLIGHT_NICKS 506
#define TS_MAX_DELTA 507
#define TS_WARN_DELTA 508
#define TWODOTS 509
#define TYPE 510
#define UNKLINE 511
#define USE_LOGGING 512
#define USE_TARGET_CHANGE 513
#define USER 514
#define VHOST 515
#define VHOST6 516
#define WARN_NO_NLINE 517
#define WLINE 518
#define XLINE 519

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 159 "conf_parser.y" /* yacc.c:355  */

  int number;
  char *string;

#line 770 "conf_parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CONF_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 787 "conf_parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1633

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  271
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  352
/* YYNRULES -- Number of rules.  */
#define YYNRULES  771
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1544

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   519

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   269,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   270,   265,
       2,   268,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   267,     2,   266,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   427,   427,   428,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   461,   461,   462,   466,   470,   474,   478,   482,   486,
     490,   496,   496,   497,   498,   499,   500,   507,   506,   521,
     521,   522,   522,   522,   522,   522,   524,   537,   543,   549,
     561,   564,   564,   565,   565,   565,   565,   567,   573,   579,
     587,   586,   635,   635,   636,   636,   636,   637,   637,   638,
     639,   641,   649,   681,   707,   715,   724,   723,   745,   745,
     746,   746,   747,   748,   750,   765,   825,   866,   868,   868,
     869,   869,   870,   870,   871,   871,   872,   872,   873,   874,
     875,   876,   879,   894,   909,   918,   932,   941,   969,   999,
    1024,  1046,  1068,  1077,  1079,  1079,  1080,  1080,  1081,  1081,
    1083,  1092,  1101,  1114,  1113,  1131,  1131,  1132,  1132,  1132,
    1134,  1140,  1151,  1150,  1176,  1176,  1178,  1178,  1178,  1178,
    1180,  1186,  1192,  1193,  1193,  1194,  1221,  1220,  1237,  1237,
    1238,  1239,  1240,  1241,  1242,  1243,  1244,  1246,  1252,  1258,
    1269,  1280,  1291,  1305,  1306,  1306,  1308,  1308,  1309,  1311,
    1318,  1318,  1331,  1332,  1334,  1334,  1335,  1335,  1337,  1345,
    1348,  1354,  1353,  1359,  1359,  1360,  1364,  1368,  1372,  1376,
    1380,  1384,  1388,  1392,  1403,  1402,  1483,  1483,  1484,  1484,
    1484,  1485,  1485,  1485,  1485,  1486,  1486,  1487,  1488,  1488,
    1490,  1496,  1502,  1508,  1519,  1525,  1531,  1542,  1549,  1548,
    1554,  1554,  1555,  1556,  1561,  1566,  1571,  1576,  1581,  1586,
    1591,  1596,  1601,  1606,  1611,  1618,  1617,  1623,  1623,  1625,
    1630,  1635,  1640,  1645,  1650,  1655,  1660,  1665,  1670,  1675,
    1680,  1685,  1692,  1691,  1697,  1697,  1698,  1702,  1706,  1710,
    1714,  1718,  1722,  1726,  1730,  1734,  1738,  1742,  1746,  1750,
    1754,  1758,  1762,  1766,  1770,  1774,  1778,  1782,  1786,  1790,
    1794,  1798,  1802,  1813,  1812,  1871,  1871,  1872,  1873,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1881,  1881,
    1881,  1881,  1882,  1883,  1884,  1885,  1886,  1888,  1894,  1900,
    1906,  1912,  1918,  1924,  1930,  1936,  1942,  1948,  1954,  1961,
    1967,  1973,  1979,  1988,  1997,  2004,  2003,  2009,  2009,  2010,
    2014,  2025,  2024,  2031,  2030,  2036,  2036,  2037,  2041,  2045,
    2049,  2053,  2059,  2059,  2060,  2060,  2060,  2060,  2060,  2060,
    2063,  2062,  2068,  2068,  2070,  2089,  2112,  2118,  2124,  2134,
    2133,  2198,  2198,  2199,  2199,  2199,  2199,  2200,  2200,  2200,
    2201,  2201,  2202,  2202,  2204,  2210,  2216,  2222,  2234,  2233,
    2239,  2239,  2240,  2244,  2248,  2252,  2256,  2260,  2264,  2268,
    2272,  2276,  2280,  2284,  2290,  2304,  2313,  2322,  2330,  2343,
    2342,  2357,  2357,  2358,  2358,  2358,  2358,  2360,  2366,  2372,
    2382,  2384,  2384,  2385,  2385,  2387,  2403,  2402,  2427,  2427,
    2428,  2428,  2428,  2428,  2430,  2436,  2456,  2455,  2461,  2461,
    2462,  2466,  2470,  2474,  2478,  2482,  2486,  2490,  2494,  2498,
    2502,  2506,  2516,  2515,  2536,  2536,  2537,  2537,  2537,  2539,
    2546,  2545,  2551,  2551,  2552,  2556,  2560,  2564,  2568,  2572,
    2576,  2580,  2584,  2588,  2598,  2597,  2684,  2684,  2685,  2685,
    2685,  2686,  2686,  2687,  2687,  2687,  2688,  2688,  2689,  2689,
    2689,  2690,  2690,  2691,  2693,  2699,  2705,  2711,  2724,  2737,
    2743,  2749,  2755,  2761,  2765,  2774,  2773,  2778,  2778,  2779,
    2783,  2789,  2800,  2806,  2812,  2823,  2822,  2848,  2848,  2849,
    2849,  2849,  2851,  2871,  2881,  2880,  2907,  2907,  2908,  2908,
    2908,  2910,  2916,  2925,  2927,  2927,  2928,  2928,  2930,  2948,
    2947,  2970,  2970,  2971,  2971,  2971,  2973,  2979,  2988,  2991,
    2991,  2992,  2992,  2993,  2993,  2994,  2994,  2995,  2995,  2996,
    2996,  2997,  2998,  2999,  2999,  3000,  3000,  3001,  3001,  3001,
    3002,  3002,  3003,  3004,  3004,  3005,  3006,  3006,  3007,  3007,
    3007,  3008,  3008,  3008,  3009,  3009,  3010,  3010,  3010,  3011,
    3011,  3012,  3013,  3013,  3014,  3014,  3015,  3016,  3017,  3018,
    3019,  3019,  3019,  3020,  3021,  3022,  3022,  3022,  3023,  3023,
    3023,  3024,  3025,  3028,  3033,  3039,  3048,  3054,  3060,  3066,
    3072,  3077,  3082,  3091,  3096,  3101,  3106,  3111,  3116,  3121,
    3126,  3131,  3136,  3141,  3146,  3152,  3163,  3168,  3173,  3178,
    3183,  3188,  3193,  3196,  3201,  3204,  3209,  3214,  3219,  3224,
    3229,  3234,  3239,  3244,  3249,  3254,  3259,  3268,  3277,  3282,
    3287,  3292,  3297,  3303,  3302,  3307,  3312,  3317,  3329,  3334,
    3334,  3335,  3339,  3343,  3347,  3351,  3355,  3359,  3363,  3367,
    3371,  3375,  3379,  3385,  3384,  3389,  3389,  3391,  3395,  3399,
    3403,  3407,  3411,  3415,  3419,  3423,  3427,  3431,  3435,  3439,
    3445,  3444,  3449,  3449,  3450,  3454,  3458,  3462,  3466,  3470,
    3474,  3478,  3482,  3486,  3490,  3494,  3499,  3508,  3513,  3518,
    3523,  3528,  3537,  3540,  3540,  3541,  3542,  3542,  3543,  3544,
    3545,  3546,  3547,  3548,  3548,  3549,  3549,  3550,  3550,  3552,
    3557,  3562,  3567,  3572,  3577,  3582,  3587,  3592,  3597,  3602,
    3607,  3612,  3620,  3623,  3623,  3624,  3624,  3625,  3626,  3627,
    3628,  3628,  3629,  3630,  3632,  3638,  3644,  3650,  3656,  3665,
    3679,  3685
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACCEPT_PASSWORD", "ACCOUNT_WHOIS",
  "ADMIN", "AFTYPE", "ANTI_NICK_FLOOD", "ANTI_SPAM_EXIT_MESSAGE_TIME",
  "AUTOCONN", "BYTES", "KBYTES", "MBYTES", "CA_FILE", "CALLER_ID_WAIT",
  "CAN_FLOOD", "CHANNEL", "CIDR_BITLEN_IPV4", "CIDR_BITLEN_IPV6",
  "CIPHER_LIST", "CLASS", "CLOAK", "CLOAK_KEY", "CLOAK_KEY1", "CLOAK_KEY2",
  "CLOAK_KEY3", "CONNECT", "CONNECTFREQ", "CYCLE_ON_HOST_CHANGE",
  "DEFAULT", "DEFAULT_FLOODCOUNT", "DEFAULT_FLOODTIME",
  "DEFAULT_SPLIT_SERVER_COUNT", "DEFAULT_SPLIT_USER_COUNT", "DEFER",
  "DENY", "DESCRIPTION", "DIE", "DISABLE_AUTH", "DISABLE_CHMODES",
  "DISABLE_FAKE_CHANNELS", "DISABLE_REMOTE_COMMANDS", "DNSBL",
  "DNSBL_EXEMPT", "DOTS_IN_IDENT", "DURATION", "EMAIL", "ENABLE_EXTBANS",
  "ENABLE_FORWARDING", "ENCRYPTED", "EXCEED_LIMIT", "EXEMPT",
  "FAILED_OPER_NOTICE", "FLATTEN_LINKS", "FLOOD_BURST", "FLOOD_LIMIT",
  "GECOS", "GENERAL", "GLINE", "GLINE_DURATION", "GLINE_ENABLE",
  "GLINE_EXEMPT", "GLINE_MIN_CIDR", "GLINE_MIN_CIDR6",
  "GLINE_REQUEST_DURATION", "HAVENT_READ_CONF", "HIDDEN", "HIDDEN_NAME",
  "HIDE_IDLE_FROM_OPERS", "HIDE_SERVER_IPS", "HIDE_SERVERS",
  "HIDE_SERVICES", "HIDE_SPOOF_IPS", "HOST", "HTTP", "HUB", "HUB_MASK",
  "IDENTITY", "IGNORE_BOGUS_TS", "INVISIBLE_ON_CONNECT", "INVITE_THROTTLE",
  "IP", "IRCD_AUTH", "IRCD_FLAGS", "IRCD_SID", "JOIN_FLOOD_COUNT",
  "JOIN_FLOOD_TIME", "KILL", "KILL_CHASE_TIME_LIMIT", "KLINE",
  "KLINE_EXEMPT", "KLINE_REASON", "KNOCK_DELAY", "KNOCK_DELAY_CHANNEL",
  "LEAF_MASK", "T_LINK", "LINKS_DELAY", "LISTEN", "MASK", "MATCH",
  "MAX_ACCEPT", "MAX_BANS", "MAX_CHANNELS", "MAX_CHANS_PER_USER",
  "MAX_GLOBAL", "MAX_IDLE", "MAX_LOCAL", "MAX_NICK_CHANGES",
  "MAX_NICK_LENGTH", "MAX_NICK_TIME", "MAX_NUMBER", "MAX_TARGETS",
  "MAX_TOPIC_LENGTH", "MAX_WATCH", "MIN_IDLE", "MIN_NONWILDCARD",
  "MIN_NONWILDCARD_SIMPLE", "MODULE", "MODULES", "MOTD", "NAME",
  "NEED_ACCOUNT", "NEED_IDENT", "NEED_PASSWORD", "NETWORK_DESC",
  "NETWORK_NAME", "NICK", "NICK_COLLIDE_REALHOST", "NO_CREATE_ON_SPLIT",
  "NO_JOIN_ON_SPLIT", "NO_OPER_FLOOD", "NO_TILDE", "NUMBER",
  "NUMBER_PER_CIDR", "NUMBER_PER_IP", "OPER_ONLY", "OPER_ONLY_UMODES",
  "OPER_PASS_RESV", "OPER_SNOMASKS", "OPER_UMODES", "OPERATOR",
  "OPERS_BYPASS_CALLERID", "PACE_WAIT", "PACE_WAIT_SIMPLE", "PASSWORD",
  "PATH", "PING_COOKIE", "PING_TIME", "PORT", "QSTRING", "QUIET_ON_BAN",
  "RANDOM_IDLE", "REASON", "REDIRPORT", "REDIRSERV", "REHASH", "REMOTE",
  "REMOTEBAN", "RESV", "RESV_EXEMPT", "RSA_PRIVATE_KEY_FILE",
  "RSA_PUBLIC_KEY_FILE", "SCRIPT", "SECONDS", "MINUTES", "HOURS", "DAYS",
  "WEEKS", "MONTHS", "YEARS", "SEND_PASSWORD", "SENDQ", "SERVERHIDE",
  "SERVERINFO", "SERVER_NAME", "SESSION", "SHORT_MOTD", "T_SNOMASKS",
  "SOFT_SENDQ", "SPOOF", "SPOOF_NOTICE", "SQUIT", "SSL_CERTIFICATE_FILE",
  "SSL_CERTIFICATE_FINGERPRINT", "SSL_CONNECTION_REQUIRED",
  "SSL_DH_ELLIPTIC_CURVE", "SSL_DH_PARAM_FILE",
  "SSL_MESSAGE_DIGEST_ALGORITHM", "SSLPROFILE", "SSL_PROFILE",
  "STATS_E_DISABLED", "STATS_I_OPER_ONLY", "STATS_K_OPER_ONLY",
  "STATS_M_OPER_ONLY", "STATS_O_OPER_ONLY", "STATS_P_OPER_ONLY",
  "STATS_U_OPER_ONLY", "T_ALIAS", "T_ALL", "T_BOTS", "T_CALLERID",
  "T_CCONN", "T_CLUSTER", "T_DEAF", "T_DEBUG", "T_DLINE", "T_FARCONNECT",
  "T_FILE", "T_FULL", "T_HIDECHANNELS", "T_GLOBOPS", "T_INVISIBLE",
  "T_IPV4", "T_IPV6", "T_LOCOPS", "T_LOG", "T_MAX_CLIENTS", "T_NCHANGE",
  "T_NOCTCP", "T_NONONREG", "T_OPERWALL", "T_RECVQ", "T_REJ", "T_RESTART",
  "T_SASL_NAME", "T_SERVER", "T_SERVICE", "T_SERVICES_NAME",
  "T_SERVNOTICE", "T_SET", "T_SHARED", "T_SIZE", "T_SKILL",
  "T_SOFTCALLERID", "T_SPY", "T_SSL", "T_UMODES", "T_UNAUTH", "T_UNDLINE",
  "T_UNLIMITED", "T_UNRESV", "T_UNXLINE", "T_WALLOP", "T_WALLOPS",
  "T_WALLUSERS", "T_WEBIRC", "TBOOL", "THROTTLE_NUM", "THROTTLE_TIME",
  "TKLINE_EXPIRE_NOTICES", "TMASKED", "MASS_HIGHLIGHT_NICKS",
  "TS_MAX_DELTA", "TS_WARN_DELTA", "TWODOTS", "TYPE", "UNKLINE",
  "USE_LOGGING", "USE_TARGET_CHANGE", "USER", "VHOST", "VHOST6",
  "WARN_NO_NLINE", "WLINE", "XLINE", "';'", "'}'", "'{'", "'='", "','",
  "':'", "$accept", "conf", "conf_item", "timespec_", "timespec",
  "sizespec_", "sizespec", "alias_entry", "$@1", "alias_items",
  "alias_item", "alias_name", "alias_user", "alias_host",
  "alias_oper_only", "modules_entry", "modules_items", "modules_item",
  "modules_module", "modules_script", "modules_path", "sslprofile", "$@2",
  "sslprofile_items", "sslprofile_item", "sslprofile_name",
  "sslprofile_dh_param_file", "sslprofile_dh_elliptic_curve",
  "sslprofile_cipher_list", "sslprofile_cafile", "sslprofile_identity",
  "$@3", "sslprofile_identity_items", "sslprofile_identity_item",
  "sslprofile_identity_server_name",
  "sslprofile_identity_rsa_private_key_file",
  "sslprofile_identity_certificate_file", "serverinfo_entry",
  "serverinfo_items", "serverinfo_item", "serverinfo_name",
  "serverinfo_sid", "serverinfo_description", "serverinfo_network_name",
  "serverinfo_network_desc", "serverinfo_vhost", "serverinfo_vhost6",
  "serverinfo_max_clients", "serverinfo_max_nick_length",
  "serverinfo_max_topic_length", "serverinfo_hub", "admin_entry",
  "admin_items", "admin_item", "admin_name", "admin_email",
  "admin_description", "motd_entry", "$@4", "motd_items", "motd_item",
  "motd_mask", "motd_file", "dnsbl_entry", "$@5", "dnsbl_items",
  "dnsbl_item", "dnsbl_name", "dnsbl_reason", "dnsbl_matches",
  "match_items", "match_item", "cloak_entry", "$@6", "cloak_items",
  "cloak_item", "cloak_name", "cloak_default", "cloak_key", "cloak_key1",
  "cloak_key2", "cloak_key3", "logging_entry", "logging_items",
  "logging_item", "logging_use_logging", "logging_file_entry", "$@7",
  "logging_file_items", "logging_file_item", "logging_file_name",
  "logging_file_size", "logging_file_type", "$@8",
  "logging_file_type_items", "logging_file_type_item", "oper_entry", "$@9",
  "oper_items", "oper_item", "oper_name", "oper_user", "oper_password",
  "oper_encrypted", "oper_rsa_public_key_file",
  "oper_ssl_certificate_fingerprint", "oper_ssl_connection_required",
  "oper_class", "oper_umodes", "$@10", "oper_umodes_items",
  "oper_umodes_item", "oper_snomasks", "$@11", "oper_snomasks_items",
  "oper_snomasks_item", "oper_flags", "$@12", "oper_flags_items",
  "oper_flags_item", "class_entry", "$@13", "class_items", "class_item",
  "class_name", "class_ping_time", "class_number_per_ip",
  "class_connectfreq", "class_max_number", "class_max_global",
  "class_max_local", "class_soft_sendq", "class_flood_burst",
  "class_flood_limit", "class_sendq", "class_recvq",
  "class_cidr_bitlen_ipv4", "class_cidr_bitlen_ipv6",
  "class_number_per_cidr", "class_min_idle", "class_max_idle",
  "class_max_channels", "class_flags", "$@14", "class_flags_items",
  "class_flags_item", "listen_entry", "$@15", "listen_flags", "$@16",
  "listen_flags_items", "listen_flags_item", "listen_items", "listen_item",
  "listen_port", "$@17", "port_items", "port_item", "listen_address",
  "listen_host", "listen_ssl_profile", "auth_entry", "$@18", "auth_items",
  "auth_item", "auth_user", "auth_passwd", "auth_class", "auth_encrypted",
  "auth_flags", "$@19", "auth_flags_items", "auth_flags_item",
  "auth_spoof", "auth_redir_serv", "auth_redir_port",
  "auth_ssl_certificate_fingerprint", "auth_ca_file", "resv_entry", "$@20",
  "resv_items", "resv_item", "resv_mask", "resv_reason", "resv_exempt",
  "service_entry", "service_items", "service_item", "service_name",
  "shared_entry", "$@21", "shared_items", "shared_item", "shared_name",
  "shared_user", "shared_type", "$@22", "shared_types", "shared_type_item",
  "cluster_entry", "$@23", "cluster_items", "cluster_item", "cluster_name",
  "cluster_type", "$@24", "cluster_types", "cluster_type_item",
  "connect_entry", "$@25", "connect_items", "connect_item", "connect_name",
  "connect_host", "connect_vhost", "connect_send_password",
  "connect_accept_password", "connect_ssl_certificate_fingerprint",
  "connect_ca_file", "connect_ssl_profile", "connect_port",
  "connect_aftype", "connect_flags", "$@26", "connect_flags_items",
  "connect_flags_item", "connect_encrypted", "connect_hub_mask",
  "connect_leaf_mask", "connect_class", "kill_entry", "$@27", "kill_items",
  "kill_item", "kill_user", "kill_reason", "deny_entry", "$@28",
  "deny_items", "deny_item", "deny_ip", "deny_reason", "exempt_entry",
  "exempt_items", "exempt_item", "exempt_ip", "gecos_entry", "$@29",
  "gecos_items", "gecos_item", "gecos_name", "gecos_reason",
  "general_entry", "general_items", "general_item", "general_max_watch",
  "general_cycle_on_host_change", "general_cloak_key",
  "general_account_whois", "general_gline_enable",
  "general_gline_duration", "general_gline_request_duration",
  "general_gline_min_cidr", "general_gline_min_cidr6",
  "general_kline_reason", "general_tkline_expire_notices",
  "general_kill_chase_time_limit", "general_hide_spoof_ips",
  "general_ignore_bogus_ts", "general_failed_oper_notice",
  "general_anti_nick_flood", "general_max_nick_time",
  "general_max_nick_changes", "general_max_accept",
  "general_anti_spam_exit_message_time", "general_ts_warn_delta",
  "general_ts_max_delta", "general_havent_read_conf",
  "general_invisible_on_connect", "general_warn_no_nline",
  "general_stats_e_disabled", "general_stats_o_oper_only",
  "general_stats_P_oper_only", "general_stats_u_oper_only",
  "general_stats_k_oper_only", "general_stats_i_oper_only",
  "general_stats_m_oper_only", "general_pace_wait",
  "general_caller_id_wait", "general_opers_bypass_callerid",
  "general_pace_wait_simple", "general_short_motd",
  "general_no_oper_flood", "general_oper_pass_resv",
  "general_dots_in_ident", "general_max_targets", "general_services_name",
  "general_sasl_name", "general_ping_cookie",
  "general_nick_collide_realhost", "general_disable_auth",
  "general_throttle_num", "general_throttle_time", "general_oper_umodes",
  "$@30", "general_enable_extbans", "general_enable_forwarding",
  "general_ssl_message_digest_algorithm", "general_mass_highlight_nicks",
  "umode_oitems", "umode_oitem", "general_oper_snomasks", "$@31",
  "snomask_oitems", "snomask_oitem", "general_oper_only_umodes", "$@32",
  "umode_items", "umode_item", "general_disable_chmodes",
  "general_use_target_change", "general_min_nonwildcard",
  "general_min_nonwildcard_simple", "general_default_floodcount",
  "general_default_floodtime", "channel_entry", "channel_items",
  "channel_item", "channel_disable_fake_channels", "channel_knock_delay",
  "channel_knock_delay_channel", "channel_max_chans_per_user",
  "channel_max_bans", "channel_default_split_user_count",
  "channel_default_split_server_count", "channel_no_create_on_split",
  "channel_no_join_on_split", "channel_jflood_count",
  "channel_jflood_time", "channel_quiet_on_ban", "channel_invite_throttle",
  "serverhide_entry", "serverhide_items", "serverhide_item",
  "serverhide_flatten_links", "serverhide_disable_remote_commands",
  "serverhide_hide_servers", "serverhide_hide_services",
  "serverhide_hidden_name", "serverhide_links_delay", "serverhide_hidden",
  "serverhide_hide_server_ips", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,    59,   125,   123,    61,    44,
      58
};
# endif

#define YYPACT_NINF -1185

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1185)))

#define YYTABLE_NINF -181

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1185,   736, -1185,  -232,  -251,  -244, -1185, -1185, -1185, -1185,
   -1185,  -222, -1185,  -217, -1185, -1185, -1185,  -214, -1185, -1185,
   -1185,  -212,  -211, -1185, -1185, -1185,  -197,  -180, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185,   381,   813,  -178,
    -173,  -170,  -168,  -159,    24,  -157,   430,  -149,  -133,  -121,
     303,  -120,  -109,  -102,   946,   439,   -96,   -89,   -75,    87,
      11,   -72,   -68,   -66,   -39,   -33,     3, -1185, -1185, -1185,
   -1185, -1185,   -16,   -15,    -5,    32,    38,    46,    48,    55,
      56,    64,    95,   107,   115,   249, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
     757,   613,   590,    14,   404, -1185,   116,    36, -1185, -1185,
      10, -1185,   121,   127,   132,   136,   145,   148,   185,   186,
     187,   188,   189,   194,   196,   198,   199,   203,   204,   205,
     208,   211,   212,   213,   215,   216,   217,   219,   223,   229,
     230,   232,   237,   242,   243,   244, -1185,   245, -1185, -1185,
     248,   252,   254,   257,   263,   264,   266,   267,   268,   270,
     272,   274,   276,   280,   282,   284,   290,   293,   294,   297,
     306,   307,   309,    13, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185,   506,    92,   338,   -38,
     311,   313,   314,    18, -1185, -1185, -1185, -1185,    27,   450,
      23, -1185,   315,   316,   317,   318,   320,   322,   324,   327,
      45, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
      20,   330,   331,   332,   333,   334,   336,   337,   339,   341,
     344,   345,   106, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,   368,   190,    63,    26,   347,
      81, -1185, -1185, -1185,    85, -1185,   348,    17, -1185, -1185,
     138, -1185,   160,   184,   292,   164, -1185,   225,   271,   260,
     486,   487,   486,   486,   486,   496,   497,   384,   385,   386,
     375, -1185,   376,   377,   379,   383,   388,   390, -1185,   393,
     394,   396,   399,   400,   401,   402,   403,   406,   407,   408,
     412,   419,   193, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185,   378,   422,   423,   426,   434,   435,   436,
       7, -1185, -1185, -1185, -1185, -1185, -1185, -1185,   387,   438,
     444,   445,   447,   448,   449,   451, -1185,   454,   455,   457,
     459,   462,   463,   472,   173, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185,   474,   475,    80, -1185, -1185, -1185,   433,   476,
     477,   478,    65, -1185, -1185, -1185, -1185,   495,   453, -1185,
   -1185,   480,   481,   135, -1185, -1185, -1185,   504,   505,   486,
     486,   500,   507,   521,   533,   508,   610,   629,   517,   518,
     520,   486,   523,   635,   640,   486,   644,   534,   535,   536,
     486,   634,   653,   654,   486,   656,   657,   658,   659,   548,
     550,   529,   552,   537,   538,   556,   486,   486,   557,   561,
     661,   562,  -224,  -188,   567,   569,   570,   571,   670,   671,
     689,   486,   576,   692,   486,   486,   579,   580,   563, -1185,
     564,   559,   566,   568, -1185,   575,   581,   583,   584,   589,
     592,    89, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185,   597,   598,   102, -1185, -1185, -1185,
     573,   600,   602, -1185,   606,   607, -1185,   197, -1185, -1185,
   -1185, -1185, -1185, -1185,   682,   683,   686,   582, -1185,   616,
     614,   617,    70, -1185, -1185, -1185,   619,   624,   632, -1185,
     639,   642,   647, -1185,   649,   650, -1185,   662,   176, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185,   660,   663,   664,   672,     8, -1185, -1185, -1185, -1185,
     666,   680,   700,   695,   702,   703,   704,   486,   693, -1185,
   -1185,   699,   708,   778,   827,   828,   815,   816,   825,   843,
     831,   833,   711, -1185,   716,   717,   720, -1185,   721,   722,
     732,   238, -1185, -1185, -1185, -1185, -1185, -1185, -1185,   718,
     734,   737,   739,   740,   166, -1185, -1185, -1185, -1185, -1185,
     719,   741, -1185,    62, -1185, -1185, -1185, -1185,   758,   745,
   -1185,   751,   870,   756, -1185,   759,   755, -1185,   760,    53,
   -1185, -1185, -1185, -1185,   761,   762,   768, -1185,   771,   772,
     773,   829,   775,   782,   783,   784,   789,   790,   791,   792,
     793,   794, -1185, -1185,   902,   929,   486,   930,   931,   796,
     943,   944,   486,   945,   947,   486,   932,   948,   950,   486,
     951,   951,   951,   819, -1185, -1185,   936,   937,   938,   939,
     844,   940,   826, -1185, -1185,   949,  -165,   952,   953,   846,
     954,   955,   810,   956,   957,   961,   958,   959,   960,   962,
     830, -1185,   963,   964,   834, -1185, -1185,   965,   966,   967,
     835, -1185,   845, -1185,   968,   969,   854, -1185,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,   881,   882,   883,   884,   885,   886,   887,
     888,   889,   669,   890,   735,   811,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   903,   904,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     916, -1185, -1185,   986,  1018,   848,   917,  1033,  1051,  1035,
    1037,  1038,  1039,   924, -1185,  1041,  1042,   927, -1185, -1185,
    1044,  1045,   928,  1063,  1048,   933, -1185,   934,   935,   941,
   -1185, -1185,  1052,  1053,   942, -1185, -1185,  1054,   850,   970,
    1055,  1056,  1059,   971,  1060,   851,   972,  1061,   976, -1185,
   -1185,  1062,  1064,  1065,   977, -1185,   978,   979,   980,   981,
     982,   983,   984,   985, -1185,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997, -1185, -1185,  1066,  1067,
     998,  1068,  1069,  1070,   999, -1185, -1185,  1071,   975,  1073,
    1074,  1001, -1185, -1185,  1075,  1000,  1002, -1185,  1004, -1185,
     118,  1005, -1185, -1185,  1076,  1003,  1077,  1007, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,   486,   486,   486,   486,   486,
     486,   486, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185,  1008,  1009,  1010,  1011,  1012,   -55,
    1013,  1014,  1015,  1016,  1017,  1019,  1020,  1021,  1022,  1023,
     397,  1024,  1025,  1026, -1185,  1027,  1028,  1029,  1030,  1031,
    1032, -1185,  1034,  1036,  1040,  1043,  1046,  1047,  1049,  1050,
       1,  1057,  1058,  1072,  1078,  1079,  1080,  1081, -1185,  1082,
    1083, -1185, -1185,  -186, -1185,  1084,  1085, -1185, -1185,  1086,
    1087, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,  -185, -1185,
   -1185,  1088,  1089,  1090, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185,   -53, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,   -41, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185,  1091,  1092,  1096,   678,  1097,  1098,  1099,  1100,
    1101,  1102, -1185,  1103,  1104, -1185,  1105,  1106,   362,   973,
    1107, -1185,  1108, -1185, -1185, -1185, -1185,  1109,  1110, -1185,
    1112,  1113,   491,  1114,  1115,  1116,   769,  1117,  1118,   832,
    1119, -1185,  1120,  1121,  1122, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,  1123,  1124,    41,  1125,  1126,
    1127, -1185,  1128,  1129,  1130,  1131, -1185,  1132,   715, -1185,
   -1185,  1133,  1134,  1135, -1185,    99, -1185, -1185, -1185, -1185,
   -1185,  1136,   681,  1139, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,   -24,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185,   951,   951,   951, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,   105, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185,   965, -1185, -1185,
   -1185, -1185, -1185,   669,  1095,  1142,  1144, -1185,   735, -1185,
     811, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185,   111, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185,   125, -1185,  1151,  1063,  1140, -1185, -1185,
   -1185, -1185, -1185, -1185,  1137, -1185, -1185,  1138, -1185, -1185,
   -1185, -1185,  1141, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185,   133, -1185, -1185,
   -1185, -1185,  1143,  1145,  1146, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185,   141, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,   153, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185,  1147,  1149,  1150,  1152,
      39, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185,   161, -1185, -1185,  1153,   -94,  1154,  1156,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185,   178, -1185, -1185, -1185,   -55, -1185,
   -1185, -1185, -1185,     1, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185,   678, -1185,   362, -1185, -1185, -1185,  1148,  1157,
    1160, -1185,   491,  1161,  1162,  1163, -1185,   769, -1185,   832,
   -1185,  1158,  1171,  1172,  1159, -1185, -1185,   715,  1164,  1165,
    1166,   637, -1185, -1185,   681, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,  1167,  1168,
    1169, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,   181, -1185, -1185, -1185, -1185,
   -1185, -1185,   637, -1185
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,   293,   156,   474,   524,
     142,     0,   539,     0,   369,   515,   341,     0,   133,   204,
     409,     0,     0,    70,    47,   452,     0,     0,   426,     3,
       5,    24,    25,    12,     4,    26,    27,    28,     6,     7,
       9,    10,    11,    14,    15,    16,    17,    18,    19,    20,
      21,    23,    22,     8,    13,    29,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   125,   126,   128,
     127,   738,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   724,   735,   726,   727,
     728,   725,   729,   730,   731,   732,   733,   734,   736,   737,
       0,     0,     0,     0,     0,   537,     0,     0,   535,   536,
       0,   612,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   700,     0,   683,   663,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   550,   600,   603,   604,   605,   593,
     594,   595,   596,   597,   598,   592,   561,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   588,   562,   563,
     599,   565,   571,   572,   566,   568,   569,   567,   580,   581,
     570,   573,   574,   575,   564,   577,   601,   602,   589,   590,
     591,   586,   587,   578,   608,   609,   610,   611,   579,   576,
     606,   607,   584,   585,   582,   583,     0,     0,     0,     0,
       0,     0,     0,     0,    62,    63,    64,    65,     0,     0,
       0,   763,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   754,   755,   756,   757,   758,   761,   759,   760,   762,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    99,   100,   110,   103,   104,   105,   101,
     109,   106,   107,   108,   102,     0,     0,     0,     0,     0,
       0,   175,   176,   177,     0,   424,     0,     0,   422,   423,
       0,   129,     0,     0,     0,     0,   124,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   723,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   296,   297,   300,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   298,   299,   301,   312,
     313,   314,   315,     0,     0,     0,     0,     0,     0,     0,
       0,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,     0,     0,   505,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   487,   486,   488,   492,   489,   490,
     491,   530,     0,     0,     0,   527,   528,   529,     0,     0,
       0,     0,     0,   145,   146,   147,   148,     0,     0,   534,
     545,     0,     0,     0,   542,   543,   544,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   549,
       0,     0,     0,     0,   388,     0,     0,     0,     0,     0,
       0,     0,   372,   373,   374,   375,   380,   376,   377,   378,
     379,   381,   382,   521,     0,     0,     0,   518,   519,   520,
       0,     0,     0,   343,     0,     0,   355,     0,   353,   354,
     356,   357,   358,    66,     0,     0,     0,     0,    61,     0,
       0,     0,     0,   136,   137,   138,     0,     0,     0,   262,
       0,     0,     0,   245,     0,     0,   228,     0,     0,   207,
     208,   209,   210,   214,   215,   216,   217,   213,   211,   212,
     218,     0,     0,     0,     0,     0,   412,   413,   414,   415,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   753,
     111,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    98,     0,     0,     0,    86,     0,     0,
       0,     0,    73,    74,    75,    76,    77,    78,    79,     0,
       0,     0,     0,     0,     0,    50,    51,    52,    53,    54,
       0,     0,   460,     0,   455,   456,   457,   178,     0,     0,
     174,     0,     0,     0,   421,     0,     0,   436,     0,     0,
     429,   430,   431,   432,     0,     0,     0,   123,     0,     0,
       0,    31,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   722,   316,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   295,   166,     0,     0,     0,     0,
       0,     0,     0,   158,   493,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   476,     0,     0,     0,   526,   149,     0,     0,     0,
       0,   144,     0,   533,     0,     0,     0,   541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   548,   383,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   371,     0,     0,     0,   517,   359,
       0,     0,     0,     0,     0,     0,   352,     0,     0,     0,
      60,   139,     0,     0,     0,   135,   219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   206,
     416,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   752,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    97,    80,     0,     0,
       0,     0,     0,     0,     0,    72,    55,     0,     0,     0,
       0,     0,    49,   458,     0,     0,     0,   454,     0,   173,
       0,     0,   420,   433,     0,     0,     0,     0,   428,   132,
     131,   130,   745,   744,   739,    31,    31,    31,    31,    31,
      31,    31,    33,    32,   751,   748,   749,   740,   741,   743,
     742,   746,   747,   750,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      41,     0,     0,     0,   294,     0,     0,     0,     0,     0,
       0,   157,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   475,     0,
       0,   525,   155,     0,   154,     0,     0,   143,   538,     0,
       0,   540,   616,   628,   632,   648,   615,   614,   720,   721,
     660,   716,   654,   665,   666,   627,   618,   617,   620,   621,
     619,   635,   625,   626,   636,   624,   622,   631,   630,   629,
     655,   613,   718,   719,   659,   652,   712,   705,   706,   709,
     713,   704,   714,   707,   708,   711,   715,   710,     0,   703,
     653,   699,   688,   690,   691,   693,   692,   695,   694,   697,
     696,     0,   686,   679,   672,   673,   676,   680,   671,   681,
     674,   675,   678,   682,   677,     0,   670,   649,   647,   650,
     658,   651,   667,   638,   644,   645,   642,   643,   646,   639,
     640,   641,   657,   656,   661,   662,   623,   668,   634,   633,
     717,   637,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   370,     0,     0,   516,     0,     0,     0,   364,
     360,   363,     0,   342,    67,    69,    68,     0,     0,   134,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   232,
       0,   205,     0,     0,     0,   410,   765,   764,   770,   768,
     771,   766,   767,   769,   114,   122,   113,   120,   121,   112,
     116,   115,   119,   117,   118,     0,     0,     0,     0,     0,
       0,    71,     0,     0,     0,     0,    48,     0,     0,   453,
     179,     0,     0,     0,   191,     0,   183,   184,   186,   185,
     425,     0,     0,     0,   427,    34,    35,    36,    37,    38,
      39,    40,   329,   330,   320,   325,   326,   340,   339,     0,
     338,   334,   322,   333,   323,   321,   332,   317,   331,   319,
     318,    41,    41,    41,    43,    42,   327,   324,   328,   169,
     170,   171,   172,   168,   167,   498,   503,   504,   500,   514,
     511,   495,   512,   509,   510,     0,   508,   513,   494,   502,
     497,   499,   501,   496,   531,   532,   152,     0,   150,   151,
     546,   547,   701,     0,     0,     0,     0,   684,     0,   664,
       0,   408,   386,   387,   397,   395,   393,   399,   394,   402,
     396,   403,   398,   400,   392,   401,     0,   391,   385,   406,
     405,   404,   407,   384,   523,   522,   367,   366,   351,   348,
     350,   349,   347,     0,   346,     0,     0,     0,   368,   140,
     141,   227,   223,   284,   271,   281,   280,   269,   274,   292,
     283,   290,   273,   276,   267,   286,   289,   268,   285,   282,
     291,   277,   279,   287,   288,   275,   278,     0,   265,   220,
     222,   224,   261,   250,   252,   253,   254,   256,   257,   255,
     259,   258,     0,   248,   225,   226,   241,   234,   235,   238,
     242,   233,   243,   236,   237,   240,   244,   239,     0,   231,
     221,   419,   417,   418,    85,    84,     0,     0,     0,     0,
       0,    89,    90,    91,    92,    81,    83,    82,    56,    59,
      58,    57,   459,   464,   470,   473,   466,   472,   467,   471,
     469,   465,   468,     0,   463,   187,     0,     0,     0,     0,
     182,   434,   440,   446,   449,   451,   442,   448,   443,   447,
     445,   441,   450,   444,     0,   439,   435,   336,     0,    44,
      45,    46,   506,     0,   153,   702,   698,   687,   689,   685,
     669,   389,     0,   344,     0,   365,   362,   361,     0,     0,
       0,   263,     0,     0,     0,     0,   246,     0,   229,   232,
      93,     0,     0,     0,     0,    88,   461,     0,     0,     0,
       0,     0,   181,   437,     0,   337,   507,   390,   345,   270,
     266,   272,   264,   260,   249,   251,   247,   230,     0,     0,
       0,    87,   462,   188,   190,   189,   197,   202,   201,   196,
     199,   203,   200,   195,   198,     0,   194,   438,    95,    94,
      96,   192,     0,   193
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1185, -1185, -1185,   112,  -337, -1184,  -730, -1185, -1185, -1185,
     565, -1185, -1185, -1185, -1185, -1185, -1185,   974, -1185, -1185,
   -1185, -1185, -1185, -1185,   577, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185,  -198, -1185, -1185, -1185, -1185, -1185,  1155,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185,  1177, -1185, -1185, -1185, -1185, -1185, -1185,
     648, -1185, -1185, -1185, -1185, -1185,   779, -1185, -1185, -1185,
   -1185,   -54, -1185, -1185, -1185,   836, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185,  1006, -1185, -1185, -1185, -1185,    19,
   -1185, -1185, -1185, -1185, -1185,  -310, -1185, -1185, -1185,   705,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185,  -254, -1185, -1185, -1185,  -181, -1185, -1185, -1185,  -172,
   -1185, -1185, -1185,  1093, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,  -134, -1185, -1185, -1185, -1185,
   -1185,  -147, -1185,   742, -1185, -1185, -1185,   -11, -1185, -1185,
   -1185, -1185, -1185, -1185,   787, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185,  -143, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185,   723, -1185, -1185, -1185, -1185, -1185,  1111, -1185, -1185,
   -1185, -1185,   641, -1185, -1185, -1185, -1185, -1185,  -171, -1185,
   -1185, -1185,   667, -1185, -1185, -1185, -1185,  -166, -1185, -1185,
   -1185,   918, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185,  -131, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185,   780, -1185, -1185, -1185, -1185, -1185,  1094,
   -1185, -1185, -1185, -1185,  1207, -1185, -1185, -1185, -1185,  1170,
   -1185, -1185, -1185, -1185,  1179, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
      35, -1185, -1185, -1185,    43, -1185, -1185, -1185,    60, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185,  1234, -1185, -1185,
   -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185, -1185,  1173, -1185, -1185, -1185, -1185, -1185, -1185,
   -1185, -1185
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    29,   962,   963,  1254,  1255,    30,    77,   664,
     665,   666,   667,   668,   669,    31,   263,   264,   265,   266,
     267,    32,    76,   651,   652,   653,   654,   655,   656,   657,
     658,   920,  1410,  1411,  1412,  1413,  1414,    33,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    34,    86,    87,    88,    89,    90,    35,    71,   582,
     583,   584,   585,    36,    63,   452,   453,   454,   455,   456,
    1023,  1024,    37,    60,   400,   401,   402,   403,   404,   405,
     406,   407,    38,   320,   321,   322,   323,   324,  1215,  1216,
    1217,  1218,  1219,  1438,  1535,  1536,    39,    72,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   886,
    1398,  1399,   609,   883,  1382,  1383,   610,   879,  1367,  1368,
      40,    59,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   719,  1239,  1240,    41,    69,   566,   862,
    1333,  1334,   567,   568,   569,  1337,  1150,  1151,   570,   571,
     572,    42,    67,   541,   542,   543,   544,   545,   546,   547,
     846,  1316,  1317,   548,   549,   550,   551,   552,    43,    73,
     615,   616,   617,   618,   619,    44,   327,   328,   329,    45,
      81,   689,   690,   691,   692,   693,   945,  1454,  1455,    46,
      78,   673,   674,   675,   676,   935,  1433,  1434,    47,    61,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   752,  1275,  1276,   437,   438,   439,   440,
      48,    68,   556,   557,   558,   559,    49,    62,   444,   445,
     446,   447,    50,   127,   128,   129,    51,    65,   463,   464,
     465,   466,    52,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   504,   244,   245,   246,   247,  1105,
    1106,   248,   503,  1091,  1092,   249,   501,  1078,  1079,   250,
     251,   252,   253,   254,   255,    53,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    54,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     991,   992,   993,   702,    82,   704,   705,   706,   393,   611,
    1273,   460,   325,  1237,   131,   441,    57,   132,   325,   259,
     133,   134,   823,    58,   611,   125,   824,   135,   579,   394,
     395,   396,   397,    55,    56,   136,   398,   125,   990,    83,
    1406,   137,  1406,   138,   139,    64,   271,  1003,  1004,    84,
      66,   140,   141,    70,   685,    74,    75,   142,   825,   612,
     143,   144,   826,   670,   670,   145,   448,  1459,  1460,  1461,
      79,   579,   146,   147,   612,   148,   149,   150,   151,  1286,
    1292,   441,   318,  1287,  1293,   152,   272,    80,   318,   120,
     530,   153,   154,   553,   121,   442,  1238,   122,   273,   123,
    1211,   155,   531,   553,   156,   126,   613,   290,   124,   532,
     130,   274,   275,   157,   276,   277,   278,   126,   256,  1211,
     158,   613,   159,    85,   160,   580,   161,   399,   162,   163,
     461,   326,   780,   781,   257,   260,   460,   326,   533,   685,
     164,   279,   291,   165,   792,  1499,   258,   268,   796,   166,
     167,   168,   169,   801,   170,   171,   172,   805,   269,   173,
     614,   442,   462,   261,   449,   270,   443,   659,   580,   817,
     818,   315,   534,   686,   408,   614,   409,   586,   316,   410,
     262,   292,   671,   671,   834,   450,   411,   837,   838,   174,
     293,   659,   317,   412,   352,   330,   587,   331,   560,  1407,
     175,  1407,   332,   176,   177,   178,   179,   180,   181,   182,
     353,   354,  1297,  1408,   294,  1408,  1298,   451,   295,  1212,
     355,  1409,   413,  1409,  1299,   588,   296,   573,  1300,   333,
     297,   298,   443,   535,   581,   334,  1274,   183,  1212,   644,
     184,  1457,   536,   537,   554,  1458,   414,   356,   357,   415,
      91,   645,   337,   338,   554,   461,   416,   646,   686,   589,
     185,   186,   187,   339,   188,   189,   190,   417,   538,   335,
     561,   191,   539,   742,   894,   192,   358,   581,   562,   528,
     563,    92,    93,   683,   577,   630,   660,   462,  -180,    94,
     903,   677,   681,   418,  -180,   359,   590,   360,   361,   362,
     340,   661,   458,   363,   259,  1494,   341,   364,   687,   694,
     660,   628,   688,   365,   342,   647,   343,   672,   672,   947,
     591,   419,   299,   344,   345,   661,   366,   367,   936,    95,
    1213,   770,   346,   695,    96,    97,   874,   592,   319,   560,
     368,    98,    99,   420,   319,   564,   764,   679,   540,  1213,
     100,   555,   101,   593,  1214,   853,   421,   698,   648,   594,
     595,   555,   422,   347,   369,  1439,   300,   301,   857,   644,
    1462,   370,   642,  1214,  1463,   348,  1471,   102,   103,   976,
    1472,   645,    82,   349,   457,   982,   565,   646,   985,   467,
    1473,   662,   989,   687,  1474,   468,  1328,   688,  1481,   104,
     469,   776,  1482,   699,   470,   448,  1486,  1251,  1252,  1253,
    1487,   561,   596,   471,   371,   662,   472,    83,  1488,   562,
     260,   563,  1489,   649,   650,   663,  1496,    84,  1329,   697,
    1497,   131,   931,   423,   132,   597,  1330,   133,   134,   760,
     290,   696,   888,  1503,   135,   647,  1541,  1504,   261,   663,
    1542,   586,   136,   473,   474,   475,   476,   477,   137,   733,
     138,   139,   478,   865,   479,   262,   480,   481,   140,   141,
     587,   482,   483,   484,   142,   291,   485,   143,   144,   486,
     487,   488,   145,   489,   490,   491,   564,   492,   648,   146,
     147,   493,   148,   149,   150,   151,  1343,   494,   495,   588,
     496,    85,   152,   449,   924,   497,   700,   530,   153,   154,
     498,   499,   500,   502,   292,   350,   505,  1344,   155,   531,
     506,   156,   507,   293,   450,   508,   532,   565,  1345,   990,
     157,   509,   510,   589,   511,   512,   513,   158,   514,   159,
     515,   160,   516,   161,   517,   162,   163,   294,   518,  1346,
     519,   295,   520,   649,   650,   533,   451,   164,   521,   296,
     165,   522,   523,   297,   298,   524,   166,   167,   168,   169,
     590,   170,   171,   172,   525,   526,   173,   527,  1347,   574,
    1348,   575,   576,   620,   621,   622,   623,  1331,   624,   534,
     625,   408,   626,   409,   591,   627,   410,  1332,   631,   632,
     633,   634,   635,   411,   636,   637,   174,   638,  1349,   639,
     412,   592,   640,   641,   393,   678,   682,   175,   701,   703,
     176,   177,   178,   179,   180,   181,   182,   593,   707,   708,
     709,   710,   711,   594,   595,   394,   395,   396,   397,   413,
     712,   713,   398,   735,   772,   714,  1350,   715,  1351,   782,
     535,   716,   744,   784,   183,   299,   717,   184,   718,   536,
     537,   720,   721,   414,   722,   785,   415,   723,   724,   725,
     726,   727,  1352,   416,   728,   729,   730,   185,   186,   187,
     731,   188,   189,   190,   417,   538,   596,   732,   191,   539,
     736,   737,   192,  1304,   738,  1526,  1353,  1354,   766,   300,
     301,  1355,   739,   740,   741,  1356,   745,  1500,  1357,   597,
     418,  1358,   746,   747,  1359,   748,   749,   750,   773,   751,
    1360,  1305,   753,   754,  1527,   755,  1528,   756,  1306,  1361,
     757,   758,  1362,   399,  1363,  1364,     2,     3,   419,  1307,
     759,     4,   762,   763,   767,   768,   769,  1365,   774,   775,
     778,   779,     5,   783,   786,  1366,     6,     7,   352,   787,
     420,   788,     8,   789,   790,   540,   791,   794,  1308,   793,
    1442,     9,   795,   421,   353,   354,   797,  1529,    10,   422,
     798,   799,   800,   802,   355,   803,   804,    11,   806,   807,
     808,   809,    12,    13,   810,  1530,   811,   812,   813,  1309,
    1310,  1311,   816,   819,  1423,   814,   815,   820,   822,  1312,
     821,   356,   357,   827,    91,   828,   829,   830,    14,   831,
     832,   833,   835,    15,   836,   839,   840,   843,   841,   842,
    1081,   867,   868,    16,   844,   869,   845,  1313,   859,  1443,
     358,  1531,  1532,   847,   899,    92,    93,   870,   905,   848,
     423,   849,   850,    94,    17,    18,  1444,   851,  1314,   359,
     852,   360,   361,   362,  1372,   855,   856,   363,   860,  1066,
     861,   364,  1067,  1424,   863,   864,    19,   365,  1068,  1445,
    1069,   871,   872,  1070,   876,   873,  1446,  1071,  1072,  1073,
     366,   367,   877,    95,    20,  1447,  1533,  1074,    96,    97,
     878,  1534,  1075,  1076,   368,    98,    99,   880,    21,    22,
     881,  1077,   896,  1425,   100,   882,   101,   884,   885,  1448,
    1426,  1449,  1450,  1315,    23,   890,   897,   907,   369,  1427,
     887,   891,   892,    24,  1082,   370,  1083,  1451,    25,  1084,
     893,   102,   103,  1085,  1452,  1453,   898,   271,   900,   901,
     902,    26,  1086,  1428,   906,  1429,  1430,  1087,   904,   908,
     909,   701,    27,   104,   910,   911,    28,  1088,  1373,  1089,
    1374,  1431,  1090,  1375,   912,   913,   916,  1376,   371,  1432,
     914,   917,   915,   926,   933,   918,  1377,   272,   919,   921,
     922,  1378,   955,   956,   957,   958,   959,   960,   961,   273,
     923,  1379,   927,  1380,   938,   928,  1381,   929,   930,   934,
     939,  1093,   274,   275,  1094,   276,   277,   278,   940,   941,
    1095,   942,  1096,   944,   943,  1097,   949,   950,   946,  1098,
    1099,  1100,  1386,   951,   974,  1387,   952,   953,   954,  1101,
     964,  1388,   279,  1389,  1102,  1103,  1390,   965,   966,   967,
    1391,  1392,  1393,  1104,   968,   969,   970,   971,   972,   973,
    1394,   975,   977,   978,   979,  1395,  1396,  1225,  1226,  1227,
    1228,  1229,  1230,  1231,  1397,   980,   981,   983,  1010,   984,
     987,   986,   988,   990,   994,   995,   996,   997,   998,  1000,
     999,  1001,  1007,  1013,  1134,  1018,  1161,  1168,  1002,  1021,
    1027,  1005,  1006,  1008,  1009,  1011,  1012,  1014,  1015,  1016,
    1028,  1017,  1019,  1020,  1022,  1025,  1026,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1132,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1080,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1133,  1118,  1119,
    1120,  1121,  1122,  1123,  1124,  1125,  1126,  1127,  1128,  1129,
    1130,  1131,  1136,  1137,  1138,  1135,  1139,  1140,  1141,  1142,
    1143,  1144,  1145,  1146,  1147,  1149,  1148,  1152,  1153,  1154,
    1155,  1157,  1158,  1160,  1163,  1164,  1156,  1159,  1165,  1167,
    1170,  1172,  1495,  1173,  1174,  1195,  1196,  1198,  1199,  1200,
    1202,  1203,  1204,  1205,  1207,  1221,  1223,  1335,   925,   932,
     875,   771,  1543,  1464,  1440,  1517,   743,   578,  1162,  1166,
    1169,  1171,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,
    1183,  1466,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,
    1192,  1193,  1194,   336,  1201,  1197,  1206,  1209,  1208,  1210,
    1220,  1222,  1224,  1232,  1233,  1234,  1235,  1236,  1241,  1242,
    1243,  1244,  1245,  1475,  1246,  1247,  1248,  1249,  1250,  1256,
    1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1467,  1265,
    1468,  1266,  1498,   889,  1509,  1267,  1516,  1518,  1268,   866,
    1512,  1269,  1270,  1510,  1271,  1272,  1511,  1513,  1514,  1515,
    1519,  1520,  1277,  1278,  1505,  1476,   680,  1508,   854,  1507,
     948,  1522,  1506,  1537,   459,  1470,   858,  1279,   895,   351,
     937,  1469,   761,  1280,  1281,  1282,  1283,  1284,  1285,  1288,
    1289,  1290,  1291,  1465,     0,     0,  1301,  1302,  1294,  1295,
    1296,  1303,  1318,  1319,  1320,  1321,  1322,  1323,  1324,  1325,
    1326,  1327,   529,  1338,  1339,  1340,  1336,  1341,  1342,  1369,
    1370,  1371,  1384,  1385,  1400,  1401,  1402,  1403,  1404,  1405,
    1415,  1416,  1417,  1418,  1419,  1420,  1421,  1422,  1435,     0,
       0,  1441,  1436,  1437,  1456,  1477,     0,  1478,  1479,     0,
       0,  1480,  1490,  1483,     0,  1484,  1485,  1491,  1492,     0,
    1493,  1502,  1501,     0,  1521,     0,     0,     0,     0,  1523,
    1524,  1525,  1538,  1539,  1540,     0,     0,     0,   684,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   629,     0,     0,     0,   643,     0,     0,
       0,     0,     0,     0,     0,   734,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   765,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   777
};

static const yytype_int16 yycheck[] =
{
     730,   731,   732,   340,     1,   342,   343,   344,     1,     1,
       9,     1,     1,    68,     1,     1,   267,     4,     1,     1,
       7,     8,   246,   267,     1,     1,   250,    14,     1,    22,
      23,    24,    25,   265,   266,    22,    29,     1,   132,    36,
       1,    28,     1,    30,    31,   267,     1,   212,   213,    46,
     267,    38,    39,   267,     1,   267,   267,    44,   246,    51,
      47,    48,   250,     1,     1,    52,     1,  1251,  1252,  1253,
     267,     1,    59,    60,    51,    62,    63,    64,    65,   265,
     265,     1,     1,   269,   269,    72,    41,   267,     1,   267,
       1,    78,    79,     1,   267,    81,   151,   267,    53,   267,
       1,    88,    13,     1,    91,    81,    98,     1,   267,    20,
     267,    66,    67,   100,    69,    70,    71,    81,   267,     1,
     107,    98,   109,   120,   111,    98,   113,   120,   115,   116,
     120,   120,   469,   470,   267,   117,     1,   120,    49,     1,
     127,    96,    36,   130,   481,   239,   267,   267,   485,   136,
     137,   138,   139,   490,   141,   142,   143,   494,   267,   146,
     152,    81,   152,   145,    99,   267,   152,     1,    98,   506,
     507,   267,    83,   120,     1,   152,     3,     1,   267,     6,
     162,    75,   120,   120,   521,   120,    13,   524,   525,   176,
      84,     1,   267,    20,     1,   267,    20,   265,     1,   160,
     187,   160,   268,   190,   191,   192,   193,   194,   195,   196,
      17,    18,   265,   174,   108,   174,   269,   152,   112,   120,
      27,   182,    49,   182,   265,    49,   120,   265,   269,   268,
     124,   125,   152,   144,   207,   268,   235,   224,   120,     1,
     227,   265,   153,   154,   152,   269,    73,    54,    55,    76,
       1,    13,   268,   268,   152,   120,    83,    19,   120,    83,
     247,   248,   249,   268,   251,   252,   253,    94,   179,   266,
      73,   258,   183,   266,   266,   262,    83,   207,    81,   266,
      83,    32,    33,   266,   266,   265,   120,   152,   207,    40,
     627,   265,   207,   120,   207,   102,   120,   104,   105,   106,
     268,   135,   266,   110,     1,   266,   268,   114,   255,   149,
     120,   266,   259,   120,   268,    77,   268,   255,   255,   266,
     144,   148,   216,   268,   268,   135,   133,   134,   266,    80,
     231,   266,   268,   149,    85,    86,   266,   161,   257,     1,
     147,    92,    93,   170,   257,   148,   266,   266,   259,   231,
     101,   259,   103,   177,   255,   266,   183,   132,   120,   183,
     184,   259,   189,   268,   171,   266,   260,   261,   266,     1,
     265,   178,   266,   255,   269,   268,   265,   128,   129,   716,
     269,    13,     1,   268,   268,   722,   189,    19,   725,   268,
     265,   225,   729,   255,   269,   268,    34,   259,   265,   150,
     268,   266,   269,   132,   268,     1,   265,    10,    11,    12,
     269,    73,   236,   268,   221,   225,   268,    36,   265,    81,
     117,    83,   269,   185,   186,   259,   265,    46,    66,   265,
     269,     1,   266,   260,     4,   259,    74,     7,     8,   266,
       1,   149,   266,   265,    14,    77,   265,   269,   145,   259,
     269,     1,    22,   268,   268,   268,   268,   268,    28,   266,
      30,    31,   268,   266,   268,   162,   268,   268,    38,    39,
      20,   268,   268,   268,    44,    36,   268,    47,    48,   268,
     268,   268,    52,   268,   268,   268,   148,   268,   120,    59,
      60,   268,    62,    63,    64,    65,     5,   268,   268,    49,
     268,   120,    72,    99,   266,   268,   246,     1,    78,    79,
     268,   268,   268,   268,    75,   266,   268,    26,    88,    13,
     268,    91,   268,    84,   120,   268,    20,   189,    37,   132,
     100,   268,   268,    83,   268,   268,   268,   107,   268,   109,
     268,   111,   268,   113,   268,   115,   116,   108,   268,    58,
     268,   112,   268,   185,   186,    49,   152,   127,   268,   120,
     130,   268,   268,   124,   125,   268,   136,   137,   138,   139,
     120,   141,   142,   143,   268,   268,   146,   268,    87,   268,
      89,   268,   268,   268,   268,   268,   268,   225,   268,    83,
     268,     1,   268,     3,   144,   268,     6,   235,   268,   268,
     268,   268,   268,    13,   268,   268,   176,   268,   117,   268,
      20,   161,   268,   268,     1,   268,   268,   187,   132,   132,
     190,   191,   192,   193,   194,   195,   196,   177,   132,   132,
     246,   246,   246,   183,   184,    22,    23,    24,    25,    49,
     265,   265,    29,   265,   149,   268,   155,   268,   157,   149,
     144,   268,   265,   132,   224,   216,   268,   227,   268,   153,
     154,   268,   268,    73,   268,   132,    76,   268,   268,   268,
     268,   268,   181,    83,   268,   268,   268,   247,   248,   249,
     268,   251,   252,   253,    94,   179,   236,   268,   258,   183,
     268,   268,   262,    15,   268,    58,   205,   206,   265,   260,
     261,   210,   268,   268,   268,   214,   268,  1437,   217,   259,
     120,   220,   268,   268,   223,   268,   268,   268,   265,   268,
     229,    43,   268,   268,    87,   268,    89,   268,    50,   238,
     268,   268,   241,   120,   243,   244,     0,     1,   148,    61,
     268,     5,   268,   268,   268,   268,   268,   256,   268,   268,
     246,   246,    16,   246,   246,   264,    20,    21,     1,   149,
     170,   132,    26,   246,   246,   259,   246,   132,    90,   246,
      89,    35,   132,   183,    17,    18,   132,   140,    42,   189,
     246,   246,   246,   149,    27,   132,   132,    51,   132,   132,
     132,   132,    56,    57,   246,   158,   246,   268,   246,   121,
     122,   123,   246,   246,    89,   268,   268,   246,   246,   131,
     149,    54,    55,   246,     1,   246,   246,   246,    82,   149,
     149,   132,   246,    87,   132,   246,   246,   268,   265,   265,
      95,   149,   149,    97,   268,   149,   268,   159,   265,   158,
      83,   204,   205,   268,   149,    32,    33,   265,   149,   268,
     260,   268,   268,    40,   118,   119,   175,   268,   180,   102,
     268,   104,   105,   106,    95,   268,   268,   110,   268,   200,
     268,   114,   203,   158,   268,   268,   140,   120,   209,   198,
     211,   265,   268,   214,   265,   268,   205,   218,   219,   220,
     133,   134,   268,    80,   158,   214,   259,   228,    85,    86,
     268,   264,   233,   234,   147,    92,    93,   268,   172,   173,
     268,   242,   246,   198,   101,   268,   103,   268,   268,   238,
     205,   240,   241,   245,   188,   265,   246,   149,   171,   214,
     268,   268,   268,   197,   199,   178,   201,   256,   202,   204,
     268,   128,   129,   208,   263,   264,   246,     1,   246,   246,
     246,   215,   217,   238,   246,   240,   241,   222,   265,   132,
     132,   132,   226,   150,   149,   149,   230,   232,   199,   234,
     201,   256,   237,   204,   149,   132,   265,   208,   221,   264,
     149,   265,   149,   265,   265,   268,   217,    41,   268,   268,
     268,   222,   163,   164,   165,   166,   167,   168,   169,    53,
     268,   232,   268,   234,   246,   268,   237,   268,   268,   268,
     265,   200,    66,    67,   203,    69,    70,    71,   267,   149,
     209,   265,   211,   268,   265,   214,   265,   265,   268,   218,
     219,   220,   200,   265,   132,   203,   265,   265,   265,   228,
     265,   209,    96,   211,   233,   234,   214,   265,   265,   265,
     218,   219,   220,   242,   265,   265,   265,   265,   265,   265,
     228,   132,   132,   132,   268,   233,   234,   955,   956,   957,
     958,   959,   960,   961,   242,   132,   132,   132,   268,   132,
     132,   149,   132,   132,   265,   149,   149,   149,   149,   149,
     246,   265,   246,   132,   246,   265,   246,   246,   149,   265,
     265,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     265,   149,   149,   149,   149,   149,   149,   149,   149,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   149,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   149,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   149,   132,   149,   268,   149,   149,   149,   265,
     149,   149,   265,   149,   149,   132,   268,   149,   265,   265,
     265,   149,   149,   149,   149,   149,   265,   265,   149,   149,
     149,   149,  1410,   149,   149,   149,   149,   149,   149,   149,
     149,   246,   149,   149,   149,   149,   149,   254,   651,   664,
     582,   452,  1542,  1287,  1215,  1489,   400,   263,   268,   268,
     268,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   156,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,    86,   265,   267,   265,   265,   268,   265,
     265,   268,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   132,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   156,   265,
     156,   265,   149,   598,   156,   265,  1487,   149,   265,   567,
    1482,   265,   265,   156,   265,   265,   156,   156,   156,   156,
     149,   149,   265,   265,  1458,  1336,   320,  1474,   541,  1472,
     689,  1497,  1463,  1504,   127,  1300,   556,   265,   615,   105,
     673,  1298,   424,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,  1293,    -1,    -1,   265,   265,   270,   270,
     270,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   193,   265,   265,   265,   269,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,    -1,
      -1,   265,   268,   268,   265,   265,    -1,   270,   270,    -1,
      -1,   270,   265,   270,    -1,   270,   270,   268,   268,    -1,
     268,   265,   268,    -1,   265,    -1,    -1,    -1,    -1,   265,
     265,   265,   265,   265,   265,    -1,    -1,    -1,   327,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   280,    -1,    -1,    -1,   302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   372,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   444,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   463
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   272,     0,     1,     5,    16,    20,    21,    26,    35,
      42,    51,    56,    57,    82,    87,    97,   118,   119,   140,
     158,   172,   173,   188,   197,   202,   215,   226,   230,   273,
     278,   286,   292,   308,   322,   328,   334,   343,   353,   367,
     391,   417,   432,   449,   456,   460,   470,   479,   501,   507,
     513,   517,   523,   596,   612,   265,   266,   267,   267,   392,
     344,   480,   508,   335,   267,   518,   267,   433,   502,   418,
     267,   329,   368,   450,   267,   267,   293,   279,   471,   267,
     267,   461,     1,    36,    46,   120,   323,   324,   325,   326,
     327,     1,    32,    33,    40,    80,    85,    86,    92,    93,
     101,   103,   128,   129,   150,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     267,   267,   267,   267,   267,     1,    81,   514,   515,   516,
     267,     1,     4,     7,     8,    14,    22,    28,    30,    31,
      38,    39,    44,    47,    48,    52,    59,    60,    62,    63,
      64,    65,    72,    78,    79,    88,    91,   100,   107,   109,
     111,   113,   115,   116,   127,   130,   136,   137,   138,   139,
     141,   142,   143,   146,   176,   187,   190,   191,   192,   193,
     194,   195,   196,   224,   227,   247,   248,   249,   251,   252,
     253,   258,   262,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   576,   577,   578,   579,   582,   586,
     590,   591,   592,   593,   594,   595,   267,   267,   267,     1,
     117,   145,   162,   287,   288,   289,   290,   291,   267,   267,
     267,     1,    41,    53,    66,    67,    69,    70,    71,    96,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
       1,    36,    75,    84,   108,   112,   120,   124,   125,   216,
     260,   261,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   267,   267,   267,     1,   257,
     354,   355,   356,   357,   358,     1,   120,   457,   458,   459,
     267,   265,   268,   268,   268,   266,   324,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     266,   598,     1,    17,    18,    27,    54,    55,    83,   102,
     104,   105,   106,   110,   114,   120,   133,   134,   147,   171,
     178,   221,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,     1,    22,    23,    24,    25,    29,   120,
     345,   346,   347,   348,   349,   350,   351,   352,     1,     3,
       6,    13,    20,    49,    73,    76,    83,    94,   120,   148,
     170,   183,   189,   260,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   497,   498,   499,
     500,     1,    81,   152,   509,   510,   511,   512,     1,    99,
     120,   152,   336,   337,   338,   339,   340,   268,   266,   515,
       1,   120,   152,   519,   520,   521,   522,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   587,   268,   583,   575,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   266,   525,
       1,    13,    20,    49,    83,   144,   153,   154,   179,   183,
     259,   434,   435,   436,   437,   438,   439,   440,   444,   445,
     446,   447,   448,     1,   152,   259,   503,   504,   505,   506,
       1,    73,    81,    83,   148,   189,   419,   423,   424,   425,
     429,   430,   431,   265,   268,   268,   268,   266,   288,     1,
      98,   207,   330,   331,   332,   333,     1,    20,    49,    83,
     120,   144,   161,   177,   183,   184,   236,   259,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   383,
     387,     1,    51,    98,   152,   451,   452,   453,   454,   455,
     268,   268,   268,   268,   268,   268,   268,   268,   266,   614,
     265,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   266,   310,     1,    13,    19,    77,   120,   185,
     186,   294,   295,   296,   297,   298,   299,   300,   301,     1,
     120,   135,   225,   259,   280,   281,   282,   283,   284,   285,
       1,   120,   255,   472,   473,   474,   475,   265,   268,   266,
     355,   207,   268,   266,   458,     1,   120,   255,   259,   462,
     463,   464,   465,   466,   149,   149,   149,   265,   132,   132,
     246,   132,   275,   132,   275,   275,   275,   132,   132,   246,
     246,   246,   265,   265,   268,   268,   268,   268,   268,   414,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   268,   266,   394,   265,   268,   268,   268,   268,
     268,   268,   266,   346,   265,   268,   268,   268,   268,   268,
     268,   268,   494,   268,   268,   268,   268,   268,   268,   268,
     266,   482,   268,   268,   266,   510,   265,   268,   268,   268,
     266,   337,   149,   265,   268,   268,   266,   520,   246,   246,
     275,   275,   149,   246,   132,   132,   246,   149,   132,   246,
     246,   246,   275,   246,   132,   132,   275,   132,   246,   246,
     246,   275,   149,   132,   132,   275,   132,   132,   132,   132,
     246,   246,   268,   246,   268,   268,   246,   275,   275,   246,
     246,   149,   246,   246,   250,   246,   250,   246,   246,   246,
     246,   149,   149,   132,   275,   246,   132,   275,   275,   246,
     246,   265,   265,   268,   268,   268,   441,   268,   268,   268,
     268,   268,   268,   266,   435,   268,   268,   266,   504,   265,
     268,   268,   420,   268,   268,   266,   424,   149,   149,   149,
     265,   265,   268,   268,   266,   331,   265,   268,   268,   388,
     268,   268,   268,   384,   268,   268,   380,   268,   266,   370,
     265,   268,   268,   268,   266,   452,   246,   246,   246,   149,
     246,   246,   246,   275,   265,   149,   246,   149,   132,   132,
     149,   149,   149,   132,   149,   149,   265,   265,   268,   268,
     302,   268,   268,   268,   266,   295,   265,   268,   268,   268,
     268,   266,   281,   265,   268,   476,   266,   473,   246,   265,
     267,   149,   265,   265,   268,   467,   268,   266,   463,   265,
     265,   265,   265,   265,   265,   163,   164,   165,   166,   167,
     168,   169,   274,   275,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   132,   132,   275,   132,   132,   268,
     132,   132,   275,   132,   132,   275,   149,   132,   132,   275,
     132,   277,   277,   277,   265,   149,   149,   149,   149,   246,
     149,   265,   149,   212,   213,   149,   149,   246,   149,   149,
     268,   149,   149,   132,   149,   149,   149,   149,   265,   149,
     149,   265,   149,   341,   342,   149,   149,   265,   265,   149,
     149,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   200,   203,   209,   211,
     214,   218,   219,   220,   228,   233,   234,   242,   588,   589,
     265,    95,   199,   201,   204,   208,   217,   222,   232,   234,
     237,   584,   585,   200,   203,   209,   211,   214,   218,   219,
     220,   228,   233,   234,   242,   580,   581,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   149,   149,   246,   268,   149,   132,   149,   149,
     149,   149,   265,   149,   149,   265,   149,   149,   268,   132,
     427,   428,   149,   265,   265,   265,   265,   149,   149,   265,
     149,   246,   268,   149,   149,   149,   268,   149,   246,   268,
     149,   265,   149,   149,   149,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   149,   149,   267,   149,   149,
     149,   265,   149,   246,   149,   149,   265,   149,   268,   265,
     265,     1,   120,   231,   255,   359,   360,   361,   362,   363,
     265,   149,   268,   149,   265,   274,   274,   274,   274,   274,
     274,   274,   265,   265,   265,   265,   265,    68,   151,   415,
     416,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,    10,    11,    12,   276,   277,   265,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,     9,   235,   495,   496,   265,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   269,   265,   265,
     265,   265,   265,   269,   270,   270,   270,   265,   269,   265,
     269,   265,   265,   265,    15,    43,    50,    61,    90,   121,
     122,   123,   131,   159,   180,   245,   442,   443,   265,   265,
     265,   265,   265,   265,   265,   265,   265,   265,    34,    66,
      74,   225,   235,   421,   422,   254,   269,   426,   265,   265,
     265,   265,   265,     5,    26,    37,    58,    87,    89,   117,
     155,   157,   181,   205,   206,   210,   214,   217,   220,   223,
     229,   238,   241,   243,   244,   256,   264,   389,   390,   265,
     265,   265,    95,   199,   201,   204,   208,   217,   222,   232,
     234,   237,   385,   386,   265,   265,   200,   203,   209,   211,
     214,   218,   219,   220,   228,   233,   234,   242,   381,   382,
     265,   265,   265,   265,   265,   265,     1,   160,   174,   182,
     303,   304,   305,   306,   307,   265,   265,   265,   265,   265,
     265,   265,   265,    89,   158,   198,   205,   214,   238,   240,
     241,   256,   264,   477,   478,   265,   268,   268,   364,   266,
     360,   265,    89,   158,   175,   198,   205,   214,   238,   240,
     241,   256,   263,   264,   468,   469,   265,   265,   269,   276,
     276,   276,   265,   269,   342,   589,   156,   156,   156,   585,
     581,   265,   269,   265,   269,   132,   428,   265,   270,   270,
     270,   265,   269,   270,   270,   270,   265,   269,   265,   269,
     265,   268,   268,   268,   266,   304,   265,   269,   149,   239,
     277,   268,   265,   265,   269,   416,   496,   443,   422,   156,
     156,   156,   390,   156,   156,   156,   386,   382,   149,   149,
     149,   265,   478,   265,   265,   265,    58,    87,    89,   140,
     158,   204,   205,   259,   264,   365,   366,   469,   265,   265,
     265,   265,   269,   366
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   271,   272,   272,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   274,   274,   275,   275,   275,   275,   275,   275,   275,
     275,   276,   276,   277,   277,   277,   277,   279,   278,   280,
     280,   281,   281,   281,   281,   281,   282,   283,   284,   285,
     286,   287,   287,   288,   288,   288,   288,   289,   290,   291,
     293,   292,   294,   294,   295,   295,   295,   295,   295,   295,
     295,   296,   297,   298,   299,   300,   302,   301,   303,   303,
     304,   304,   304,   304,   305,   306,   307,   308,   309,   309,
     310,   310,   310,   310,   310,   310,   310,   310,   310,   310,
     310,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   323,   324,   324,   324,   324,
     325,   326,   327,   329,   328,   330,   330,   331,   331,   331,
     332,   333,   335,   334,   336,   336,   337,   337,   337,   337,
     338,   339,   340,   341,   341,   342,   344,   343,   345,   345,
     346,   346,   346,   346,   346,   346,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   354,   355,   355,   355,   356,
     358,   357,   359,   359,   360,   360,   360,   360,   361,   362,
     362,   364,   363,   365,   365,   366,   366,   366,   366,   366,
     366,   366,   366,   366,   368,   367,   369,   369,   370,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   380,   379,
     381,   381,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   384,   383,   385,   385,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   386,
     386,   386,   388,   387,   389,   389,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   390,   390,   392,   391,   393,   393,   394,   394,   394,
     394,   394,   394,   394,   394,   394,   394,   394,   394,   394,
     394,   394,   394,   394,   394,   394,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   414,   413,   415,   415,   416,
     416,   418,   417,   420,   419,   421,   421,   422,   422,   422,
     422,   422,   423,   423,   424,   424,   424,   424,   424,   424,
     426,   425,   427,   427,   428,   428,   429,   430,   431,   433,
     432,   434,   434,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   436,   437,   438,   439,   441,   440,
     442,   442,   443,   443,   443,   443,   443,   443,   443,   443,
     443,   443,   443,   443,   444,   445,   446,   447,   448,   450,
     449,   451,   451,   452,   452,   452,   452,   453,   454,   455,
     456,   457,   457,   458,   458,   459,   461,   460,   462,   462,
     463,   463,   463,   463,   464,   465,   467,   466,   468,   468,
     469,   469,   469,   469,   469,   469,   469,   469,   469,   469,
     469,   469,   471,   470,   472,   472,   473,   473,   473,   474,
     476,   475,   477,   477,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   480,   479,   481,   481,   482,   482,
     482,   482,   482,   482,   482,   482,   482,   482,   482,   482,
     482,   482,   482,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   492,   494,   493,   495,   495,   496,
     496,   497,   498,   499,   500,   502,   501,   503,   503,   504,
     504,   504,   505,   506,   508,   507,   509,   509,   510,   510,
     510,   511,   512,   513,   514,   514,   515,   515,   516,   518,
     517,   519,   519,   520,   520,   520,   521,   522,   523,   524,
     524,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   555,   556,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   575,   574,   576,   577,   578,   579,   580,
     580,   581,   581,   581,   581,   581,   581,   581,   581,   581,
     581,   581,   581,   583,   582,   584,   584,   585,   585,   585,
     585,   585,   585,   585,   585,   585,   585,   585,   585,   585,
     587,   586,   588,   588,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   597,   598,   598,   598,   598,   598,
     598,   598,   598,   598,   598,   598,   598,   598,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   613,   614,   614,   614,   614,   614,
     614,   614,   614,   614,   615,   616,   617,   618,   619,   620,
     621,   622
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     0,     1,     2,     3,     3,     3,     0,     6,     2,
       1,     1,     1,     1,     1,     2,     4,     4,     4,     4,
       5,     2,     1,     1,     1,     1,     2,     4,     4,     4,
       0,     6,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     4,     4,     4,     4,     4,     0,     6,     2,     1,
       1,     1,     1,     2,     4,     4,     4,     5,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     5,     2,     1,     1,     1,     1,     2,
       4,     4,     4,     0,     6,     2,     1,     1,     1,     2,
       4,     4,     0,     6,     2,     1,     1,     1,     1,     2,
       4,     4,     4,     3,     1,     1,     0,     6,     2,     1,
       1,     1,     1,     1,     1,     1,     2,     4,     4,     4,
       4,     4,     4,     5,     2,     1,     1,     1,     2,     4,
       0,     6,     2,     1,     1,     1,     1,     2,     4,     4,
       4,     0,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     6,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     4,     4,     4,     4,     4,     4,     4,     0,     5,
       3,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     3,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     0,     5,     3,     1,     3,     1,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     6,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     0,     5,     3,     1,     1,
       1,     0,     6,     0,     5,     3,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     2,
       0,     5,     3,     1,     1,     3,     4,     4,     4,     0,
       6,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     4,     4,     4,     4,     0,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     0,
       6,     2,     1,     1,     1,     1,     2,     4,     4,     4,
       5,     2,     1,     1,     1,     4,     0,     6,     2,     1,
       1,     1,     1,     2,     4,     4,     0,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     1,     1,     1,     2,     4,
       0,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     6,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     0,     5,     3,     1,     1,
       1,     4,     4,     4,     4,     0,     6,     2,     1,     1,
       1,     1,     4,     4,     0,     6,     2,     1,     1,     1,
       1,     4,     4,     5,     2,     1,     1,     1,     4,     0,
       6,     2,     1,     1,     1,     1,     4,     4,     5,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     0,     5,     4,     4,     4,     4,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     5,     3,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       0,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     4,     4,     4,
       4,     4,     5,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     5,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 31:
#line 461 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3162 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 463 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number);
		}
#line 3170 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 467 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number);
		}
#line 3178 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 471 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 + (yyvsp[0].number);
		}
#line 3186 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 475 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 + (yyvsp[0].number);
		}
#line 3194 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 479 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 + (yyvsp[0].number);
		}
#line 3202 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 483 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 + (yyvsp[0].number);
		}
#line 3210 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 487 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 * 4 + (yyvsp[0].number);
                }
#line 3218 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 491 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 365 + (yyvsp[0].number);
                }
#line 3226 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 496 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3232 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 497 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number); }
#line 3238 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 498 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 3244 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 499 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 + (yyvsp[0].number); }
#line 3250 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 500 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 * 1024 + (yyvsp[0].number); }
#line 3256 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 507 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.ptr.alias = MyMalloc(sizeof(struct alias_entry));
}
#line 3267 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 513 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  dlinkAdd(block_state.ptr.alias, &block_state.ptr.alias->node, &alias_items);
  alias_add(block_state.ptr.alias);
}
#line 3279 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 525 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  struct alias_name *nm = MyMalloc(sizeof(struct alias_name));

  strlcpy(nm->name, yylval.string, sizeof(nm->name));
  nm->parent = block_state.ptr.alias;

  dlinkAdd(nm, &nm->node, &block_state.ptr.alias->names);
}
#line 3295 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 538 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->user, yylval.string, sizeof(block_state.ptr.alias->user));
}
#line 3304 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 544 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->server, yylval.string, sizeof(block_state.ptr.alias->server));
}
#line 3313 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 550 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.ptr.alias->flags |= CONF_FLAGS_OPER_ONLY;
  }
}
#line 3325 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 568 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_module(libio_basename(yylval.string));
}
#line 3334 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 574 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_script(yylval.string);
}
#line 3343 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 580 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    mod_add_path(yylval.string);
}
#line 3352 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 587 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.ssl = sslprofile_create();
}
#line 3363 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 71:
#line 594 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  dlink_node *ptr;

  if (conf_parser_ctx.pass != 1)
    break;

  DLINK_FOREACH(ptr, profile->identities.head)
  {
    struct sslprofile_identity *id = ptr->data;

    if (profile->dh)
      SSL_CTX_set_tmp_dh(id->server_ctx, profile->dh);

#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
    if (profile->curve)
      SSL_CTX_set_tmp_ecdh(id->server_ctx, profile->curve);
#endif

    if (!EmptyString(profile->cipher_list))
    {
      SSL_CTX_set_cipher_list(id->server_ctx, profile->cipher_list);

      SSL_CTX_set_cipher_list(id->client_ctx, profile->cipher_list);
    }

    if (!EmptyString(profile->ca_file))
    {
      if (!SSL_CTX_load_verify_locations(id->server_ctx, profile->ca_file, NULL))
      {
        const char *s = ERR_lib_error_string(ERR_get_error());

        ilog(LOG_TYPE_IRCD, "Could not load verify location %s -- %s", profile->ca_file, s);
      }
    }
  }

  dlinkAddTail(block_state.ptr.ssl, &block_state.ptr.ssl->node, &sslprofile_items);
  block_state.ptr.ssl = NULL;
}
#line 3408 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 642 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->name, yylval.string, sizeof(entry->name));
}
#line 3419 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 650 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
  {
    BIO *file = BIO_new_file(yylval.string, "r");

    if (file)
    {
      DH *dh = PEM_read_bio_DHparams(file, NULL, NULL, NULL);

      BIO_free(file);

      if (dh)
      {
        if (DH_size(dh) < 256)
        {
          conf_error_report("Ignoring sslprofile::dh_param_file -- need at least a 2048 bit DH prime size");
          DH_free(dh);
        }
        else
        {
          entry->dh = dh;
        }
      }
    }
    else
      conf_error_report("Ignoring sslprofile::dh_param_file -- could not open/read Diffie-Hellman parameter file");
  }
}
#line 3454 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 682 "conf_parser.y" /* yacc.c:1646  */
    {
#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
  struct sslprofile *entry = block_state.ptr.ssl;
  int nid = 0;
  EC_KEY *key = NULL;

  if (conf_parser_ctx.pass == 1)
  {
    if ((nid = OBJ_sn2nid(yylval.string)) == 0)
    {
        conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- unknown curve name");
        break;
    }

    if ((key = EC_KEY_new_by_curve_name(nid)) == NULL)
    {
      conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- could not create curve");
      break;
    }

    entry->curve = key;
  }
#endif
}
#line 3483 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 708 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->cipher_list, yylval.string, sizeof(entry->cipher_list));
}
#line 3494 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 716 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->ca_file, yylval.string, sizeof(entry->ca_file));
}
#line 3505 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 724 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.identity = sslprofile_identity_create(block_state.ptr.ssl);
}
#line 3516 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 731 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  struct sslprofile_identity *id = block_state.ptr.identity;

  if (conf_parser_ctx.pass != 1)
    break;

  if (id == NULL)
    break;

  dlinkAddTail(id, &id->node, &profile->identities);
  block_state.ptr.identity = NULL;
}
#line 3534 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 751 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  char *str;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  str = xstrdup(yylval.string);
  dlinkAdd(str, make_dlink_node(), &entry->server_names);
}
#line 3552 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 766 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  BIO *file = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  if (entry->rsa_private_key)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;
  }

  if (entry->rsa_private_key_file)
  {
    MyFree(entry->rsa_private_key_file);
    entry->rsa_private_key_file = NULL;
  }

  entry->rsa_private_key_file = xstrdup(yylval.string);

  if ((file = BIO_new_file(yylval.string, "r")) == NULL)
  {
    conf_error_report("File open failed, ignoring");
    break;
  }

  entry->rsa_private_key = PEM_read_bio_RSAPrivateKey(file, NULL, 0, NULL);

  BIO_set_close(file, BIO_CLOSE);
  BIO_free(file);

  if (entry->rsa_private_key == NULL)
  {
    conf_error_report("Couldn't extract key, ignoring");
    break;
  }

  if (!RSA_check_key(entry->rsa_private_key))
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Invalid key, ignoring");
    break;
  }

  if (RSA_size(entry->rsa_private_key) < 256)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Ignoring sslprofile::identity::rsa_private_key_file -- need at least a 2048 bit key size");
  }
}
#line 3615 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 826 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;

  if (conf_parser_ctx.pass == 1 && entry)
  {
    if (!entry->rsa_private_key_file)
    {
      conf_error_report("No rsa_private_key_file specified, SSL disabled");
      break;
    }

    if (SSL_CTX_use_certificate_chain_file(entry->server_ctx, yylval.string) <= 0 ||
        SSL_CTX_use_certificate_chain_file(entry->client_ctx, yylval.string) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not open/read certificate file");
      break;
    }

    if (SSL_CTX_use_PrivateKey_file(entry->server_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0 ||
        SSL_CTX_use_PrivateKey_file(entry->client_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }

    if (!SSL_CTX_check_private_key(entry->server_ctx) ||
        !SSL_CTX_check_private_key(entry->client_ctx))
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }
  }
}
#line 3658 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 880 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.name)
  {
    if (valid_servname(yylval.string))
      ServerInfo.name = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::name -- invalid name. Aborting.");
      exit(0);
    }
  }
}
#line 3676 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 895 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.sid)
  {
    if (valid_sid(yylval.string))
      ServerInfo.sid = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::sid -- invalid SID. Aborting.");
      exit(0);
    }
  }
}
#line 3694 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 910 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ServerInfo.description);
    ServerInfo.description = xstrdup(yylval.string);
  }
}
#line 3706 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 919 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    char *p;

    if ((p = strchr(yylval.string, ' ')) != NULL)
      *p = '\0';

    MyFree(ServerInfo.network_name);
    ServerInfo.network_name = xstrdup(yylval.string);
  }
}
#line 3723 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 933 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(ServerInfo.network_desc);
  ServerInfo.network_desc = xstrdup(yylval.string);
}
#line 3735 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 942 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip.ss.ss_family = res->ai_family;
      ServerInfo.ip.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv4_vhost = 1;
    }
  }
}
#line 3766 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 970 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost6(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip6, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip6.ss.ss_family = res->ai_family;
      ServerInfo.ip6.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv6_vhost = 1;
    }
  }
#endif
}
#line 3799 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1000 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < MAXCLIENTS_MIN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too low, setting to %d", MAXCLIENTS_MIN);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MIN;
  }
  else if ((yyvsp[-1].number) > MAXCLIENTS_MAX)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too high, setting to %d", MAXCLIENTS_MAX);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MAX;
  }
  else
    ServerInfo.max_clients = (yyvsp[-1].number);
}
#line 3827 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1025 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 9)
  {
    conf_error_report("max_nick_length too low, setting to 9");
    ServerInfo.max_nick_length = 9;
  }
  else if ((yyvsp[-1].number) > NICKLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_nick_length too high, setting to %d", NICKLEN);
    conf_error_report(buf);
    ServerInfo.max_nick_length = NICKLEN;
  }
  else
    ServerInfo.max_nick_length = (yyvsp[-1].number);
}
#line 3852 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1047 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 80)
  {
    conf_error_report("max_topic_length too low, setting to 80");
    ServerInfo.max_topic_length = 80;
  }
  else if ((yyvsp[-1].number) > TOPICLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_topic_length too high, setting to %d", TOPICLEN);
    conf_error_report(buf);
    ServerInfo.max_topic_length = TOPICLEN;
  }
  else
    ServerInfo.max_topic_length = (yyvsp[-1].number);
}
#line 3877 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1069 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ServerInfo.hub = yylval.number;
}
#line 3886 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1084 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.name);
  AdminInfo.name = xstrdup(yylval.string);
}
#line 3898 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1093 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.email);
  AdminInfo.email = xstrdup(yylval.string);
}
#line 3910 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1102 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.description);
  AdminInfo.description = xstrdup(yylval.string);
}
#line 3922 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1114 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 3931 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1118 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.file.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
    motd_add(ptr->data, block_state.file.buf);
}
#line 3948 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1135 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 3957 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1141 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 3966 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1151 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    reset_block_state();
    block_state.ptr.dnsbl = MyMalloc(sizeof(struct dnsbl_entry));
  }
}
#line 3978 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1159 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_entry *dnsbl = block_state.ptr.dnsbl;

    if (dlink_list_length(&dnsbl->matches) == 0)
    {
      /* Add a default match */
      struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));
      parse_netmask("127.0.0.0/8", &match->ip, &match->bits);
      dlinkAdd(match, &match->node, &dnsbl->matches);
    }

    dlinkAdd(dnsbl, &dnsbl->node, &dnsbl_items);
  }
}
#line 3999 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1181 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->name, yylval.string, sizeof(block_state.ptr.dnsbl->name));
}
#line 4008 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1187 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->reason, yylval.string, sizeof(block_state.ptr.dnsbl->reason));
}
#line 4017 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1195 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));

    if (parse_netmask((yyvsp[0].string), &match->ip, &match->bits) == HM_IPV4)
    {
      dlinkAdd(match, &match->node, &block_state.ptr.dnsbl->matches);
    }
    else
    {
      char buf[IRCD_BUFSIZE];

      snprintf(buf, sizeof(buf), "dnsbl match %s not an IPv4 mask, ignored", (yyvsp[0].string));
      conf_error_report(buf);

      MyFree(match);
    }
  }
}
#line 4042 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1221 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();
  block_state.ptr.cloak = MyMalloc(sizeof(struct cloak_config));
}
#line 4054 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1229 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  struct cloak_config *cloak = block_state.ptr.cloak;
  dlinkAdd(cloak, &cloak->node, &cloak_items);
}
#line 4066 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1247 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.cloak->name, yylval.string, sizeof(block_state.ptr.cloak->name));
}
#line 4075 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1253 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ptr.cloak->default_cloak = yylval.number;
}
#line 4084 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1259 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key);
    cloak->cloak_key = xstrdup(yylval.string);
  }
}
#line 4098 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1270 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key1);
    cloak->cloak_key1 = xstrdup(yylval.string);
  }
}
#line 4112 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1281 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key2);
    cloak->cloak_key2 = xstrdup(yylval.string);
  }
}
#line 4126 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1292 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key3);
    cloak->cloak_key3 = xstrdup(yylval.string);
  }
}
#line 4140 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1312 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigLoggingEntry.use_logging = yylval.number;
}
#line 4149 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1318 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 4158 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1322 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (block_state.type.value && block_state.file.buf[0])
    log_set_file(block_state.type.value, block_state.size.value,
                 block_state.file.buf);
}
#line 4171 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1338 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4182 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1346 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = (yyvsp[-1].number);
}
#line 4190 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1349 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = 0;
}
#line 4198 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1354 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = 0;
}
#line 4207 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1361 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_USER;
}
#line 4216 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1365 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_OPER;
}
#line 4225 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1369 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_GLINE;
}
#line 4234 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1373 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_XLINE;
}
#line 4243 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1377 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_RESV;
}
#line 4252 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1381 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DLINE;
}
#line 4261 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1385 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KLINE;
}
#line 4270 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1389 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KILL;
}
#line 4279 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1393 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DEBUG;
}
#line 4288 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1403 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
}
#line 4300 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1410 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;
  if (!block_state.file.buf[0] &&
      !block_state.rpass.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    conf         = conf_make(CONF_OPER);
    conf->name   = xstrdup(block_state.name.buf);
    conf->user   = xstrdup(block_state.user.buf);
    conf->host   = xstrdup(block_state.host.buf);

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);

    conf->flags = block_state.flags.value;
    conf->modes = block_state.modes.value;
    conf->snomask.local = block_state.snomask_local.value;
    conf->snomask.remote = block_state.snomask_remote.value;
    conf->port  = block_state.port.value;
    conf->htype = parse_netmask(conf->host, &conf->addr, &conf->bits);

    conf_add_class_to_conf(conf, block_state.class.buf);

    if (block_state.file.buf[0])
    {
      BIO *file = NULL;
      RSA *pkey = NULL;

      if ((file = BIO_new_file(block_state.file.buf, "r")) == NULL)
      {
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- file doesn't exist");
        break;
      }

      if ((pkey = PEM_read_bio_RSA_PUBKEY(file, NULL, 0, NULL)) == NULL)
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- Key invalid; check key syntax");
      else
      {
        if (RSA_size(pkey) > 128)
          ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- key size must be 1024 or below");
        else
          conf->rsa_public_key = pkey;
      }

      BIO_set_close(file, BIO_CLOSE);
      BIO_free(file);
    }
  }
}
#line 4377 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1491 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 4386 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1497 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 4395 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1503 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 4404 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1509 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
  else
    block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
}
#line 4418 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1520 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4427 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1526 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 4436 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1532 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_SSL;
  else
    block_state.flags.value &= ~CONF_FLAGS_SSL;
}
#line 4450 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1543 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4459 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1549 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value = 0;
}
#line 4468 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1557 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_NOCTCP;
}
#line 4477 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1562 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_DEAF;
}
#line 4486 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1567 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_HIDECHANNELS;
}
#line 4495 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1572 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_OPERWALL;
}
#line 4504 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1577 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SERVNOTICE;
}
#line 4513 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1582 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_INVISIBLE;
}
#line 4522 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1587 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_WALLOP;
}
#line 4531 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1592 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SOFTCALLERID;
}
#line 4540 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1597 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_CALLERID;
}
#line 4549 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1602 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_LOCOPS;
}
#line 4558 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1607 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_REGONLY;
}
#line 4567 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1612 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SPY;
}
#line 4576 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1618 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value = block_state.snomask_remote.value = 0;
}
#line 4585 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1626 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_bots.flag;
}
#line 4594 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1631 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_bots.flag;
}
#line 4603 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1636 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_cconn.flag;
}
#line 4612 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1641 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_cconn.flag;
}
#line 4621 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1646 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_debug.flag;
}
#line 4630 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1651 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_full.flag;
}
#line 4639 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1656 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_skill.flag;
}
#line 4648 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1661 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_nchange.flag;
}
#line 4657 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1666 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_rej.flag;
}
#line 4666 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1671 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_unauth.flag;
}
#line 4675 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1676 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_spy.flag;
}
#line 4684 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1681 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_link.flag;
}
#line 4693 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1686 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
     block_state.snomask_local.value |= sno_link.flag;
}
#line 4702 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1692 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = 0;
}
#line 4711 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1699 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL_REMOTE;
}
#line 4720 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1703 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_FARCONNECT;
}
#line 4729 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1707 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_N;
}
#line 4738 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1711 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL;
}
#line 4747 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1715 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT_REMOTE;
}
#line 4756 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1719 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT;
}
#line 4765 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1723 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT_REMOTE;
}
#line 4774 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1727 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT;
}
#line 4783 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1731 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_K;
}
#line 4792 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1735 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNKLINE;
}
#line 4801 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1739 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DLINE;
}
#line 4810 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1743 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNDLINE;
}
#line 4819 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1747 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_XLINE;
}
#line 4828 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1751 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNXLINE;
}
#line 4837 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1755 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLINE;
}
#line 4846 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1759 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DIE;
}
#line 4855 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1763 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_RESTART;
}
#line 4864 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1767 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REHASH;
}
#line 4873 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1771 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_ADMIN;
}
#line 4882 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1775 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_OPERWALL;
}
#line 4891 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1779 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLOBOPS;
}
#line 4900 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1783 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLOPS;
}
#line 4909 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1787 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLUSERS;
}
#line 4918 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1791 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_LOCOPS;
}
#line 4927 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1795 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REMOTEBAN;
}
#line 4936 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1799 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SET;
}
#line 4945 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1803 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_MODULE;
}
#line 4954 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1813 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();

  block_state.ping_freq.value = DEFAULT_PINGFREQUENCY;
  block_state.con_freq.value  = DEFAULT_CONNECTFREQUENCY;
  block_state.max_total.value = MAXIMUM_LINKS_DEFAULT;
  block_state.max_sendq.value = DEFAULT_SENDQ;
  block_state.max_recvq.value = DEFAULT_RECVQ;
}
#line 4971 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1825 "conf_parser.y" /* yacc.c:1646  */
    {
  struct ClassItem *class = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (!block_state.class.buf[0])
    break;

  if (!(class = class_find(block_state.class.buf, 0)))
    class = class_make();

  class->active = 1;
  MyFree(class->name);
  class->name = xstrdup(block_state.class.buf);
  class->ping_freq = block_state.ping_freq.value;
  class->max_perip = block_state.max_perip.value;
  class->con_freq = block_state.con_freq.value;
  class->max_total = block_state.max_total.value;
  class->max_global = block_state.max_global.value;
  class->max_local = block_state.max_local.value;
  class->soft_sendq = block_state.soft_sendq.value;
  class->flood_burst = block_state.flood_burst.value;
  class->flood_limit = block_state.flood_limit.value;
  class->max_sendq = block_state.max_sendq.value;
  class->max_recvq = block_state.max_recvq.value;

  if (block_state.min_idle.value > block_state.max_idle.value)
  {
    block_state.min_idle.value = 0;
    block_state.max_idle.value = 0;
    block_state.flags.value &= ~CLASS_FLAGS_FAKE_IDLE;
  }

  class->flags = block_state.flags.value;
  class->min_idle = block_state.min_idle.value;
  class->max_idle = block_state.max_idle.value;

  rebuild_cidr_list(class);

  class->cidr_bitlen_ipv4 = block_state.cidr_bitlen_ipv4.value;
  class->cidr_bitlen_ipv6 = block_state.cidr_bitlen_ipv6.value;
  class->number_per_cidr = block_state.number_per_cidr.value;
  class->max_channels = block_state.max_channels.value;
}
#line 5021 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1889 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 5030 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1895 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ping_freq.value = (yyvsp[-1].number);
}
#line 5039 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1901 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_perip.value = (yyvsp[-1].number);
}
#line 5048 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1907 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.con_freq.value = (yyvsp[-1].number);
}
#line 5057 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1913 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_total.value = (yyvsp[-1].number);
}
#line 5066 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1919 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_global.value = (yyvsp[-1].number);
}
#line 5075 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1925 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_local.value = (yyvsp[-1].number);
}
#line 5084 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1931 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.soft_sendq.value = (yyvsp[-1].number);
}
#line 5093 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1937 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_burst.value = (yyvsp[-1].number);
}
#line 5102 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1943 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_limit.value = (yyvsp[-1].number);
}
#line 5111 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1949 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_sendq.value = (yyvsp[-1].number);
}
#line 5120 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1955 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    if ((yyvsp[-1].number) >= CLIENT_FLOOD_MIN && (yyvsp[-1].number) <= CLIENT_FLOOD_MAX)
      block_state.max_recvq.value = (yyvsp[-1].number);
}
#line 5130 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1962 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv4.value = (yyvsp[-1].number) > 32 ? 32 : (yyvsp[-1].number);
}
#line 5139 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1968 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv6.value = (yyvsp[-1].number) > 128 ? 128 : (yyvsp[-1].number);
}
#line 5148 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1974 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.number_per_cidr.value = (yyvsp[-1].number);
}
#line 5157 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1980 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.min_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5169 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1989 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.max_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5181 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1998 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_channels.value = (yyvsp[-1].number);
}
#line 5190 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2004 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value &= CLASS_FLAGS_FAKE_IDLE;
}
#line 5199 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2011 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_RANDOM_IDLE;
}
#line 5208 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2015 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_HIDE_IDLE_FROM_OPERS;
}
#line 5217 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2025 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5226 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2031 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5235 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2038 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_SSL;
}
#line 5244 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2042 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HIDDEN;
}
#line 5253 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2046 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
   block_state.flags.value |= LISTENER_SERVER;
}
#line 5262 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2050 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HTTP;
}
#line 5271 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2054 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_DEFER;
}
#line 5280 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2063 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5289 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2071 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    add_listener((yyvsp[0].number), block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5313 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2090 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    int i;
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    for (i = (yyvsp[-2].number); i <= (yyvsp[0].number); ++i)
      add_listener(i, block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5339 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2113 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5348 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2119 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5357 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2125 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 5366 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2134 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5375 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2138 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    if (EmptyString(block_state.host.buf))
      continue;

    conf        = conf_make(CONF_CLIENT);
    conf->user  = xstrdup(block_state.user.buf);
    conf->host  = xstrdup(block_state.host.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);
    if (block_state.name.buf[0])
      conf->name = xstrdup(block_state.name.buf);

    conf->flags = block_state.flags.value;
    conf->port  = block_state.port.value;

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.ca.buf[0])
    {
      int ret;

      conf->x509_store = X509_STORE_new();
      ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
      if (ret != 1)
      {
        X509_STORE_free(conf->x509_store);
        conf->x509_store = NULL;

        ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring auth block", block_state.ca.buf);
        conf_free(conf);
        continue;
      }
    }

    conf_add_class_to_conf(conf, block_state.class.buf);
    add_conf_by_address(CONF_CLIENT, conf);
  }
}
#line 5439 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2205 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5448 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2211 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5457 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2217 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 5466 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2223 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 5480 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2234 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value &= (CONF_FLAGS_ENCRYPTED | CONF_FLAGS_SPOOF_IP);
}
#line 5489 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2241 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SPOOF_NOTICE;
}
#line 5498 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2245 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NOLIMIT;
}
#line 5507 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2249 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTKLINE;
}
#line 5516 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2253 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTDNSBL;
}
#line 5525 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2257 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_IDENTD;
}
#line 5534 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2261 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_CAN_FLOOD;
}
#line 5543 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2265 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NO_TILDE;
}
#line 5552 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2269 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTGLINE;
}
#line 5561 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2273 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTRESV;
}
#line 5570 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2277 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_WEBIRC;
}
#line 5579 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2281 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_ACCOUNT;
}
#line 5588 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2285 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_PASSWORD;
}
#line 5597 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2291 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (strlen(yylval.string) <= HOSTLEN && valid_hostname(yylval.string))
  {
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
    block_state.flags.value |= CONF_FLAGS_SPOOF_IP;
  }
  else
    ilog(LOG_TYPE_IRCD, "Spoof either is too long or contains invalid characters. Ignoring it.");
}
#line 5614 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2305 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
  block_state.flags.value |= CONF_FLAGS_REDIR;
}
#line 5626 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2314 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.flags.value |= CONF_FLAGS_REDIR;
  block_state.port.value = (yyvsp[-1].number);
}
#line 5638 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2323 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 5649 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2331 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 5660 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2343 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  strlcpy(block_state.rpass.buf, CONF_NOREASON, sizeof(block_state.rpass.buf));
}
#line 5672 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2350 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  create_resv(block_state.name.buf, block_state.rpass.buf, &block_state.mask.list);
}
#line 5683 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2361 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5692 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2367 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5701 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2373 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5710 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2388 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (valid_servname(yylval.string))
  {
    struct MaskItem *conf = conf_make(CONF_SERVICE);
    conf->name = xstrdup(yylval.string);
  }
}
#line 5725 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2403 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  strlcpy(block_state.user.buf, "*", sizeof(block_state.user.buf));
  strlcpy(block_state.host.buf, "*", sizeof(block_state.host.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5741 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2414 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_ULINE);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);
}
#line 5758 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2431 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5767 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2437 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 5789 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2456 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5798 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2463 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5807 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2467 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5816 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2471 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5825 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2475 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5834 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2479 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5843 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2483 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5852 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2487 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5861 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2491 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5870 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2495 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 5879 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2499 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_SESSION;
}
#line 5888 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2503 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_WLINE;
}
#line 5897 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2507 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 5906 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2516 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5920 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2525 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_CLUSTER);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
}
#line 5935 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2540 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5944 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2546 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5953 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2553 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5962 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2557 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5971 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2561 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5980 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2565 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5989 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2569 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5998 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2573 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 6007 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2577 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 6016 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2581 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 6025 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2585 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 6034 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2589 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 6043 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2598 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.aftype.value = AF_INET;
  block_state.port.value = PORTNUM;
}
#line 6057 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2607 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;
  struct addrinfo hints, *res;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0] ||
      !block_state.host.buf[0])
    break;

  if (!block_state.rpass.buf[0] ||
      !block_state.spass.buf[0])
    break;

  if (has_wildcards(block_state.name.buf))
    break;

  conf = conf_make(CONF_SERVER);
  conf->port = block_state.port.value;
  conf->flags = block_state.flags.value;
  conf->aftype = block_state.aftype.value;
  conf->host = xstrdup(block_state.host.buf);
  conf->name = xstrdup(block_state.name.buf);
  conf->passwd = xstrdup(block_state.rpass.buf);
  conf->spasswd = xstrdup(block_state.spass.buf);

  if (block_state.cert.buf[0])
    conf->certfp = xstrdup(block_state.cert.buf);

  dlinkMoveList(&block_state.leaf.list, &conf->leaf_list);
  dlinkMoveList(&block_state.hub.list, &conf->hub_list);

  if (block_state.bind.buf[0])
  {
    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(block_state.bind.buf, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", block_state.bind.buf);
    else
    {
      assert(res != NULL);

      memcpy(&conf->bind, res->ai_addr, res->ai_addrlen);
      conf->bind.ss.ss_family = res->ai_family;
      conf->bind.ss_len = res->ai_addrlen;
      freeaddrinfo(res);
    }
  }

  if (block_state.ca.buf[0])
  {
    int ret;

    conf->x509_store = X509_STORE_new();
    ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
    if (ret != 1)
    {
      X509_STORE_free(conf->x509_store);
      conf->x509_store = NULL;

      ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring connect block", block_state.ca.buf);
      conf_free(conf);
      break;
    }
  }

  conf->ssl_profile = xstrdup(block_state.profile.buf);

  conf_add_class_to_conf(conf, block_state.class.buf);
  lookup_confhost(conf);
}
#line 6138 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2694 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6147 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2700 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.host.buf, yylval.string, sizeof(block_state.host.buf));
}
#line 6156 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2706 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.bind.buf, yylval.string, sizeof(block_state.bind.buf));
}
#line 6165 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2712 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.spass.buf, yylval.string, sizeof(block_state.spass.buf));
}
#line 6181 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2725 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6197 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2738 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 6206 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2744 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 6215 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2750 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 6224 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2756 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = (yyvsp[-1].number);
}
#line 6233 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2762 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET;
}
#line 6242 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2766 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET6;
#endif
}
#line 6253 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2774 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value &= CONF_FLAGS_ENCRYPTED;
}
#line 6261 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2780 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_ALLOW_AUTO_CONN;
}
#line 6270 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2784 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SSL;
}
#line 6279 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2790 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 6293 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2801 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.hub.list);
}
#line 6302 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2807 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.leaf.list);
}
#line 6311 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2813 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 6320 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2823 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6329 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2827 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.user.buf[0] ||
      !block_state.host.buf[0])
    break;

  conf = conf_make(CONF_KLINE);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
  add_conf_by_address(CONF_KLINE, conf);
}
#line 6354 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2852 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 6377 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2872 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6386 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2881 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6395 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2885 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.addr.buf[0])
    break;

  if (parse_netmask(block_state.addr.buf, NULL, NULL) != HM_HOST)
  {
    conf = conf_make(CONF_DLINE);
    conf->host = xstrdup(block_state.addr.buf);

    if (block_state.rpass.buf[0])
      conf->reason = xstrdup(block_state.rpass.buf);
    else
      conf->reason = xstrdup(CONF_NOREASON);
    add_conf_by_address(CONF_DLINE, conf);
  }
}
#line 6421 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2911 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 6430 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2917 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6439 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2931 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.string[0] && parse_netmask(yylval.string, NULL, NULL) != HM_HOST)
    {
      struct MaskItem *conf = conf_make(CONF_EXEMPT);
      conf->host = xstrdup(yylval.string);

      add_conf_by_address(CONF_EXEMPT, conf);
    }
  }
}
#line 6456 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2948 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6465 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2952 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;

  conf = conf_make(CONF_XLINE);
  conf->name = xstrdup(block_state.name.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
}
#line 6487 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2974 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6496 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2980 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6505 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 613:
#line 3029 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_watch = (yyvsp[-1].number);
}
#line 6513 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 614:
#line 3034 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.cycle_on_host_change = yylval.number;
}
#line 6522 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 615:
#line 3040 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key);
    ConfigFileEntry.cloak_key = xstrdup(yylval.string);
  }
}
#line 6534 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 616:
#line 3049 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.account_whois = yylval.number;
}
#line 6543 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 617:
#line 3055 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.glines = yylval.number;
}
#line 6552 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 618:
#line 3061 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_time = (yyvsp[-1].number);
}
#line 6561 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 619:
#line 3067 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_request_time = (yyvsp[-1].number);
}
#line 6570 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 620:
#line 3073 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr = (yyvsp[-1].number);
}
#line 6578 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 621:
#line 3078 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr6 = (yyvsp[-1].number);
}
#line 6586 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 622:
#line 3083 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.kline_reason);
    ConfigFileEntry.kline_reason = xstrdup(yylval.string);
  }
}
#line 6598 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 623:
#line 3092 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.tkline_expire_notices = yylval.number;
}
#line 6606 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 624:
#line 3097 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.kill_chase_time_limit = (yyvsp[-1].number);
}
#line 6614 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 625:
#line 3102 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.hide_spoof_ips = yylval.number;
}
#line 6622 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 626:
#line 3107 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ignore_bogus_ts = yylval.number;
}
#line 6630 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 627:
#line 3112 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.failed_oper_notice = yylval.number;
}
#line 6638 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 628:
#line 3117 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_nick_flood = yylval.number;
}
#line 6646 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 629:
#line 3122 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_time = (yyvsp[-1].number);
}
#line 6654 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 630:
#line 3127 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_changes = (yyvsp[-1].number);
}
#line 6662 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 631:
#line 3132 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_accept = (yyvsp[-1].number);
}
#line 6670 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 632:
#line 3137 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_spam_exit_message_time = (yyvsp[-1].number);
}
#line 6678 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 633:
#line 3142 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ts_warn_delta = (yyvsp[-1].number);
}
#line 6686 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 634:
#line 3147 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.ts_max_delta = (yyvsp[-1].number);
}
#line 6695 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 635:
#line 3153 "conf_parser.y" /* yacc.c:1646  */
    {
  if (((yyvsp[-1].number) > 0) && conf_parser_ctx.pass == 1)
  {
    ilog(LOG_TYPE_IRCD, "You haven't read your config file properly.");
    ilog(LOG_TYPE_IRCD, "There is a line in the example conf that will kill your server if not removed.");
    ilog(LOG_TYPE_IRCD, "Consider actually reading/editing the conf file, and removing this line.");
    exit(0);
  }
}
#line 6709 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 636:
#line 3164 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.invisible_on_connect = yylval.number;
}
#line 6717 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 637:
#line 3169 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.warn_no_nline = yylval.number;
}
#line 6725 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 638:
#line 3174 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_e_disabled = yylval.number;
}
#line 6733 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 639:
#line 3179 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_o_oper_only = yylval.number;
}
#line 6741 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 640:
#line 3184 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_P_oper_only = yylval.number;
}
#line 6749 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 641:
#line 3189 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_u_oper_only = yylval.number;
}
#line 6757 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 642:
#line 3194 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 2 * yylval.number;
}
#line 6765 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 643:
#line 3197 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 1;
}
#line 6773 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 644:
#line 3202 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 2 * yylval.number;
}
#line 6781 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 645:
#line 3205 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 1;
}
#line 6789 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 646:
#line 3210 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_m_oper_only = yylval.number;
}
#line 6797 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 647:
#line 3215 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait = (yyvsp[-1].number);
}
#line 6805 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 648:
#line 3220 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.caller_id_wait = (yyvsp[-1].number);
}
#line 6813 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 649:
#line 3225 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.opers_bypass_callerid = yylval.number;
}
#line 6821 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 650:
#line 3230 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait_simple = (yyvsp[-1].number);
}
#line 6829 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 651:
#line 3235 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.short_motd = yylval.number;
}
#line 6837 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 652:
#line 3240 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.no_oper_flood = yylval.number;
}
#line 6845 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 653:
#line 3245 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_pass_resv = yylval.number;
}
#line 6853 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 654:
#line 3250 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.dots_in_ident = (yyvsp[-1].number);
}
#line 6861 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 655:
#line 3255 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_targets = (yyvsp[-1].number);
}
#line 6869 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 656:
#line 3260 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && valid_servname(yylval.string))
  {
    MyFree(ConfigFileEntry.service_name);
    ConfigFileEntry.service_name = xstrdup(yylval.string);
  }
}
#line 6881 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 657:
#line 3269 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.sasl_name);
    ConfigFileEntry.sasl_name = xstrdup(yylval.string);
  }
}
#line 6893 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 658:
#line 3278 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ping_cookie = yylval.number;
}
#line 6901 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 659:
#line 3283 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.nick_collide_realhost = yylval.number;
}
#line 6909 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 660:
#line 3288 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.disable_auth = yylval.number;
}
#line 6917 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 661:
#line 3293 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_num = yylval.number;
}
#line 6925 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 662:
#line 3298 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_time = (yyvsp[-1].number);
}
#line 6933 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 663:
#line 3303 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes = 0;
}
#line 6941 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 665:
#line 3308 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_extbans = yylval.number;
}
#line 6949 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 666:
#line 3313 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_forwarding = yylval.number;
}
#line 6957 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 667:
#line 3318 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if ((ConfigFileEntry.message_digest_algorithm = EVP_get_digestbyname(yylval.string)) == NULL)
    {
      ConfigFileEntry.message_digest_algorithm = EVP_sha1();
      conf_error_report("Ignoring general::ssl_message_digest_algorithm -- unknown message digest algorithm");
    }
  }
}
#line 6972 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 668:
#line 3330 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.mass_highlight_nicks = (yyvsp[-1].number);
}
#line 6980 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 671:
#line 3336 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_NOCTCP;
}
#line 6988 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 672:
#line 3340 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_DEAF;
}
#line 6996 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 673:
#line 3344 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_HIDECHANNELS;
}
#line 7004 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 674:
#line 3348 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_OPERWALL;
}
#line 7012 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 675:
#line 3352 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SERVNOTICE;
}
#line 7020 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 676:
#line 3356 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_INVISIBLE;
}
#line 7028 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 677:
#line 3360 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_WALLOP;
}
#line 7036 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 678:
#line 3364 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SOFTCALLERID;
}
#line 7044 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 679:
#line 3368 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_CALLERID;
}
#line 7052 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 680:
#line 3372 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_LOCOPS;
}
#line 7060 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 681:
#line 3376 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_REGONLY;
}
#line 7068 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 682:
#line 3380 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SPY;
}
#line 7076 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 683:
#line 3385 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local = ConfigFileEntry.oper_snomasks.remote = 0;
}
#line 7084 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 687:
#line 3392 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_bots.flag;
}
#line 7092 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 688:
#line 3396 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_bots.flag;
}
#line 7100 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 689:
#line 3400 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_cconn.flag;
}
#line 7108 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 690:
#line 3404 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_cconn.flag;
}
#line 7116 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 691:
#line 3408 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_debug.flag;
}
#line 7124 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 692:
#line 3412 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_nchange.flag;
}
#line 7132 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 693:
#line 3416 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_full.flag;
}
#line 7140 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 694:
#line 3420 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_skill.flag;
}
#line 7148 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 695:
#line 3424 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_rej.flag;
}
#line 7156 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 696:
#line 3428 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_unauth.flag;
}
#line 7164 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 697:
#line 3432 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_spy.flag;
}
#line 7172 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 698:
#line 3436 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_link.flag;
}
#line 7180 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 699:
#line 3440 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_link.flag;
}
#line 7188 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 700:
#line 3445 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes = 0;
}
#line 7196 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 704:
#line 3451 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_NOCTCP;
}
#line 7204 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 705:
#line 3455 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_DEAF;
}
#line 7212 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 706:
#line 3459 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_HIDECHANNELS;
}
#line 7220 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 707:
#line 3463 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_OPERWALL;
}
#line 7228 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 708:
#line 3467 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SERVNOTICE;
}
#line 7236 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 709:
#line 3471 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_INVISIBLE;
}
#line 7244 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 710:
#line 3475 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_WALLOP;
}
#line 7252 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 711:
#line 3479 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SOFTCALLERID;
}
#line 7260 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 712:
#line 3483 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CALLERID;
}
#line 7268 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 713:
#line 3487 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_LOCOPS;
}
#line 7276 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 714:
#line 3491 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_REGONLY;
}
#line 7284 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 715:
#line 3495 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SPY;
}
#line 7292 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 716:
#line 3500 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.disable_chmodes);
    ConfigFileEntry.disable_chmodes = xstrdup(yylval.string);
  }
}
#line 7304 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 717:
#line 3509 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.use_target_change = yylval.number;
}
#line 7312 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 718:
#line 3514 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard = (yyvsp[-1].number);
}
#line 7320 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 719:
#line 3519 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard_simple = (yyvsp[-1].number);
}
#line 7328 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 720:
#line 3524 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodcount = (yyvsp[-1].number);
}
#line 7336 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 721:
#line 3529 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodtime = (yyvsp[-1].number);
}
#line 7344 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3553 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.disable_fake_channels = yylval.number;
}
#line 7352 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3558 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay = (yyvsp[-1].number);
}
#line 7360 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3563 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay_channel = (yyvsp[-1].number);
}
#line 7368 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3568 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_chans_per_user = (yyvsp[-1].number);
}
#line 7376 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3573 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_bans = (yyvsp[-1].number);
}
#line 7384 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3578 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_user_count = (yyvsp[-1].number);
}
#line 7392 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3583 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_server_count = (yyvsp[-1].number);
}
#line 7400 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3588 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_create_on_split = yylval.number;
}
#line 7408 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3593 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_join_on_split = yylval.number;
}
#line 7416 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3598 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodcount = yylval.number;
}
#line 7424 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3603 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodtime = (yyvsp[-1].number);
}
#line 7432 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3608 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.quiet_on_ban = yylval.number;
}
#line 7440 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3613 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.invite_throttle = (yyvsp[-1].number);
}
#line 7448 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3633 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.flatten_links = yylval.number;
}
#line 7457 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3639 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.disable_remote_commands = yylval.number;
}
#line 7466 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3645 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_servers = yylval.number;
}
#line 7475 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3651 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_services = yylval.number;
}
#line 7484 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3657 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigServerHide.hidden_name);
    ConfigServerHide.hidden_name = xstrdup(yylval.string);
  }
}
#line 7496 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3666 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (((yyvsp[-1].number) > 0) && ConfigServerHide.links_disabled == 1)
    {
      eventAddIsh("write_links_file", write_links_file, NULL, (yyvsp[-1].number));
      ConfigServerHide.links_disabled = 0;
    }

    ConfigServerHide.links_delay = (yyvsp[-1].number);
  }
}
#line 7513 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3680 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hidden = yylval.number;
}
#line 7522 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3686 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_server_ips = yylval.number;
}
#line 7531 "conf_parser.c" /* yacc.c:1646  */
    break;


#line 7535 "conf_parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
